print("\134\3* FRIENDMOD, by TyroneSama *")

-- documentation for these is in the release post tbh
local fr_enabled = CV_RegisterVar({
	name = "fr_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamchance = CV_RegisterVar({
	name = "fr_teamchance",
	defaultvalue = "100",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_minplayers = CV_RegisterVar({
	name = "fr_minplayers",
	defaultvalue = "0",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_teamattack = CV_RegisterVar({
	name = "fr_teamattack",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function(var)
		if not var.value then
			print("\133DISABLING TEAM ATTACK SEVERELY SCREWS UP TEAMPLAY DYNAMICS AND BALANCE!")
			print("This should only be used for very specific gameplay experiments. \133Don't say I didn't warn you.")
		end
	end
})
local fr_teamwarning = CV_RegisterVar({
	name = "fr_teamwarning",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamreflect = CV_RegisterVar({
	name = "fr_teamreflect",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_teamlog = CV_RegisterVar({
	name = "fr_teamlog",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_debug = CV_RegisterVar({
	name = "fr_debug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewbattle = CV_RegisterVar({
	name = "fr_crewbattle",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_crewfill = CV_RegisterVar({
	name = "fr_crewfill",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bosschance = CV_RegisterVar({
	name = "fr_bosschance",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossrestock = CV_RegisterVar({
	name = "fr_bossrestock",
	defaultvalue = "4",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossspbgone = CV_RegisterVar({
	name = "fr_bossspbgone",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossshrinkbgone = CV_RegisterVar({
	name = "fr_bossshrinkbgone",
	defaultvalue = "2",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossprotectitem = CV_RegisterVar({
	name = "fr_bossprotectitem",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossprotectamount = CV_RegisterVar({
	name = "fr_bossprotectamount",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossprotectfront = CV_RegisterVar({
	name = "fr_bossprotectfront",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bossstartitem = CV_RegisterVar({
	name = "fr_bossstartitem",
	defaultvalue = "16",
	flags = CV_NETVAR,
	possiblevalue = {MIN = 1, MAX = 16}
})
local fr_bossstartamount = CV_RegisterVar({
	name = "fr_bossstartamount",
	defaultvalue = "3",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bossscalerestock = CV_RegisterVar({
	name = "fr_bossscalerestock",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_bosskarma = CV_RegisterVar({
	name = "fr_bosskarma",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldkarma = CV_RegisterVar({
	name = "fr_worldkarma",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldpower = CV_RegisterVar({
	name = "fr_worldpower",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldjawz = CV_RegisterVar({
	name = "fr_worldjawz",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldpoweralways = CV_RegisterVar({
	name = "fr_worldpoweralways",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldjawzalways = CV_RegisterVar({
	name = "fr_worldjawzalways",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local fr_worldreplaceitem = CV_RegisterVar({
	name = "fr_worldreplaceitem",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_worldreplaceamount = CV_RegisterVar({
	name = "fr_worldreplaceamount",
	defaultvalue = "1",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local fr_bluename = CV_RegisterVar({
	name = "fr_bluename",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_orangename = CV_RegisterVar({
	name = "fr_orangename",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_onesidename = CV_RegisterVar({
	name = "fr_onesidename",
	defaultvalue = "THE WORLD",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_forceboss = CV_RegisterVar({
	name = "fr_forceboss",
	defaultvalue = "Random",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local fr_bluecolor = CV_RegisterVar({
	name = "fr_bluecolor",
	defaultvalue = "Blue",
	flags = CV_NETVAR,
	possiblevalue = {White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})
local fr_orangecolor = CV_RegisterVar({
	name = "fr_orangecolor",
	defaultvalue = "Orange",
	flags = CV_NETVAR,
	possiblevalue = {White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})

local fr_bluecolorlocal = CV_RegisterVar({
	name = "fr_bluecolorlocal",
	defaultvalue = 0,
	possiblevalue = {MIN = 0, White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})
local fr_orangecolorlocal = CV_RegisterVar({
	name = "fr_orangecolorlocal",
	defaultvalue = 0,
	possiblevalue = {MIN = 0, White = 1, Silver = 2, Grey = 3, Nickel = 4, Black = 5, Skunk = 6, Fairy = 7, Popcorn = 8, Artichoke = 9, Pigeon = 10, Sepia = 11, Beige = 12, Walnut = 13, Brown = 14, Leather = 15, Salmon = 16, Pink = 17, Rose = 18, Brick = 19, Cinnamon = 20, Ruby = 21, Raspberry = 22, Cherry = 23, Red = 24, Crimson = 25, Maroon = 26, Lemonade = 27, Flame = 28, Scarlet = 29, Ketchup = 30, Dawn = 31, Sunset = 32, Creamsicle = 33, Orange = 34, Pumpkin = 35, Rosewood = 36, Burgundy = 37, Tangerine = 38, Peach = 39, Caramel = 40, Cream = 41, Gold = 42, Royal = 43, Bronze = 44, Copper = 45, Quarry = 46, Yellow = 47, Mustard = 48, Crocodile = 49, Olive = 50, Vomit = 51, Garden = 52, Lime = 53, Handheld = 54, Tea = 55, Pistachio = 56, Moss = 57, Camouflage = 58, RoboHood = 59, Mint = 60, Green = 61, Pinetree = 62, Emerald = 63, Swamp = 64, Dream = 65, Plague = 66, Algae = 67, Caribbean = 68, Azure = 69, Aqua = 70, Teal = 71, Cyan = 72, Jawz = 73, Cerulean = 74, Navy = 75, Platinum = 76, Slate = 77, Steel = 78, Thunder = 79, Rust = 80, Wristwatch = 81, Jet = 82, Sapphire = 83, Periwinkle = 84, Blue = 85, Blueberry = 86, Nova = 87, Pastel = 88, Moonslam = 89, Ultraviolet = 90, Dusk = 91, Bubblegum = 92, Purple = 93, Fuchsia = 94, Toxic = 95, Mauve = 96, Lavender = 97, Byzantium = 98, Pomegranate = 99, Lilac = 100}
})

local fr_teamslipstream = CV_RegisterVar({
	name = "fr_teamslipstream",
	defaultvalue = "On", //causes team members bumping one another to copy slipstream charge
	flags = CV_NETVAR, //gives more benefit to close team cohesion
	possiblevalue = CV_OnOff //probably a bad idea
})

local fr_teamslipdistance = CV_RegisterVar({
	name = "fr_teamslipdistance", //controls max distance two players can maintain a team slipstream
	defaultvalue = 600, //450 is combi ring distance, feels a little short
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})

local fr_teamslipgrace = CV_RegisterVar({
	name = "fr_teamslipgrace", //controls how long players have to get back in range
	defaultvalue = TICRATE*3, //if they go out of range of a team slipstream
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})

local fr_bluetag = CV_RegisterVar({
	name = "fr_bluetag",
	defaultvalue = "",
	flags = CV_NETVAR,
	possiblevalue = nil
})

local fr_orangetag = CV_RegisterVar({
	name = "fr_orangetag",
	defaultvalue = "",
	flags = CV_NETVAR,
	possiblevalue = nil
}) //tags can be used to assign yourself to a team without overriding team names

local fr_blueskin = CV_RegisterVar({
	name = "fr_blueskin",
	defaultvalue = "",
	flags = CV_NETVAR,
	possiblevalue = nil
})

local fr_orangeskin = CV_RegisterVar({
	name = "fr_orangeskin",
	defaultvalue = "",
	flags = CV_NETVAR,
	possiblevalue = nil
})//epic funny skin assignments per team

//except I am morally against forceskin so im adding an option to opt out
//because if your host is bad and forces bad skins then you should be able to play good skins
//also the way I am enforcing this is absolutely not shenanigans-proof

local function fr_skinoptoutchange(p, arg)
	local switcheroo = nil
	if not arg then
		CONS_Printf(p, "\133USAGE: \128Give this command something like 1, yes, on, or true if you want to use your own skin instead of your team's skin (you special snowflake).")
	return
	end
	local testarg = string.lower(arg) or ""
	if testarg == "1" or testarg == "true" or testarg == "yes" or testarg == "on" then switcheroo = true else switcheroo = false end
	if switcheroo then
		CONS_Printf(p, "You will now opt out of any friendmod-driven team skins.")
		p.frskinoptout = true
	else
		CONS_Printf(p, "You will now be assigned your friendmod team's skin if it has one.")
		p.frskinoptout = false
	end
end

COM_AddCommand("fr_skinoptout", fr_skinoptoutchange, 0)

local fr_scorereport = CV_RegisterVar({"fr_scorereport", "Off", CV_NETVAR, CV_OnOff})

-- this is used to translate team colors into text colors for HUD stuff
-- technically these should probably be different options because the text colors are pretty heavily "LOL BEST ESTIMATE MAYBE?"
-- but this is the way most people expect it to work so hey
local colLookup = { -- thanks ampersand
	-- White
	[SKINCOLOR_WHITE] = "\x80",
	[SKINCOLOR_SILVER] = "\x80",
	[SKINCOLOR_SLATE] = "\x80",

	-- V_PURPLEMAP
	[SKINCOLOR_ULTRAVIOLET] = "\x81",
	[SKINCOLOR_PURPLE] = "\x81",
	[SKINCOLOR_FUCHSIA] = "\x81",

	-- V_YELLOWMAP
	[SKINCOLOR_POPCORN] = "\x82",
	[SKINCOLOR_QUARRY] = "\x82",
	[SKINCOLOR_YELLOW] = "\x82",
	[SKINCOLOR_MUSTARD] = "\x82",
	[SKINCOLOR_CROCODILE] = "\x82",
	[SKINCOLOR_OLIVE] = "\x82",

	-- V_GREENMAP
	[SKINCOLOR_LIME] = "\x83",
	[SKINCOLOR_HANDHELD] = "\x83",
	[SKINCOLOR_MOSS] = "\x83",
	[SKINCOLOR_CAMOUFLAGE] = "\x83",
	[SKINCOLOR_ROBOHOOD] = "\x83",
	[SKINCOLOR_MINT] = "\x83",
	[SKINCOLOR_GREEN] = "\x83",
	[SKINCOLOR_PINETREE] = "\x83",
	[SKINCOLOR_ALGAE] = "\x83",
	[SKINCOLOR_PLAGUE] = "\x83",
	[SKINCOLOR_EMERALD] = "\x83",
	[SKINCOLOR_SWAMP] = "\x83",
	[SKINCOLOR_DREAM] = "\x83",

	-- V_BLUEMAP
	[SKINCOLOR_PERIWINKLE] = "\x84",
	[SKINCOLOR_BLUE] = "\x84",
	[SKINCOLOR_BLUEBERRY] = "\x84",
	[SKINCOLOR_NOVA] = "\x84",

	-- V_REDMAP
	[SKINCOLOR_CINNAMON] = "\x85",
	[SKINCOLOR_RUBY] = "\x85",
	[SKINCOLOR_RASPBERRY] = "\x85",
	[SKINCOLOR_CHERRY] = "\x85",
	[SKINCOLOR_RED] = "\x85",
	[SKINCOLOR_CRIMSON] = "\x85",
	[SKINCOLOR_MAROON] = "\x85",
	[SKINCOLOR_FLAME] = "\x85",
	[SKINCOLOR_SCARLET] = "\x85",
	[SKINCOLOR_KETCHUP] = "\x85",

	-- V_GRAYMAP
	[SKINCOLOR_GREY] = "\x86",
	[SKINCOLOR_NICKEL] = "\x86",
	[SKINCOLOR_BLACK] = "\x86",
	[SKINCOLOR_SKUNK] = "\x86",
	[SKINCOLOR_JET] = "\x86",

	-- V_ORANGEMAP
	[SKINCOLOR_DAWN] = "\x87",
	[SKINCOLOR_SUNSET] = "\x87",
	[SKINCOLOR_CREAMSICLE] = "\x87",
	[SKINCOLOR_ORANGE] = "\x87",
	[SKINCOLOR_PUMPKIN] = "\x87",
	[SKINCOLOR_ROSEWOOD] = "\x87",
	[SKINCOLOR_BURGUNDY] = "\x87",
	[SKINCOLOR_TANGERINE] = "\x87",

	-- V_SKYMAP
	[SKINCOLOR_CARIBBEAN] = "\x88",
	[SKINCOLOR_AZURE] = "\x88",
	[SKINCOLOR_AQUA] = "\x88",
	[SKINCOLOR_TEAL] = "\x88",
	[SKINCOLOR_CYAN] = "\x88",
	[SKINCOLOR_JAWZ] = "\x88",
	[SKINCOLOR_CERULEAN] = "\x88",
	[SKINCOLOR_NAVY] = "\x88",
	[SKINCOLOR_SAPPHIRE] = "\x88",

	-- V_LAVENDERMAP
	[SKINCOLOR_PASTEL] = "\x89",
	[SKINCOLOR_MOONSLAM] = "\x89",
	[SKINCOLOR_DUSK] = "\x89",
	[SKINCOLOR_TOXIC] = "\x89",
	[SKINCOLOR_MAUVE] = "\x89",
	[SKINCOLOR_LAVENDER] = "\x89",
	[SKINCOLOR_BYZANTIUM] = "\x89",
	[SKINCOLOR_POMEGRANATE] = "\x89",

	-- V_GOLDMAP
	[SKINCOLOR_GOLD] = "\x8A",
	[SKINCOLOR_ROYAL] = "\x8A",
	[SKINCOLOR_BRONZE] = "\x8A",
	[SKINCOLOR_COPPER] = "\x8A",
	[SKINCOLOR_THUNDER] = "\x8A",

	-- V_TEAMAP
	[SKINCOLOR_ARTICHOKE] = "\x8B",
	[SKINCOLOR_VOMIT] = "\x8B",
	[SKINCOLOR_GARDEN] = "\x8B",
	[SKINCOLOR_TEA] = "\x8B",
	[SKINCOLOR_PISTACHIO] = "\x8B",

	-- V_STEELMAP
	[SKINCOLOR_PIGEON] = "\x8C",
	[SKINCOLOR_PLATINUM] = "\x8C",
	[SKINCOLOR_STEEL] = "\x8C",

	-- V_PINKMAP
	[SKINCOLOR_FAIRY] = "\x8D",
	[SKINCOLOR_SALMON] = "\x8D",
	[SKINCOLOR_PINK] = "\x8D",
	[SKINCOLOR_ROSE] = "\x8D",
	[SKINCOLOR_BRICK] = "\x8D",
	[SKINCOLOR_LEMONADE] = "\x8D",
	[SKINCOLOR_BUBBLEGUM] = "\x8D",
	[SKINCOLOR_LILAC] = "\x8D",

	-- V_BROWNMAP
	[SKINCOLOR_SEPIA] = "\x8E",
	[SKINCOLOR_BEIGE] = "\x8E",
	[SKINCOLOR_WALNUT] = "\x8E",
	[SKINCOLOR_BROWN] = "\x8E",
	[SKINCOLOR_LEATHER] = "\x8E",
	[SKINCOLOR_RUST] = "\x8E",
	[SKINCOLOR_WRISTWATCH] = "\x8E",

	-- V_PEACHMAP
	[SKINCOLOR_PEACH] = "\x8F",
	[SKINCOLOR_CARAMEL] = "\x8F",
	[SKINCOLOR_CREAM] = "\x8F",
}

-- adapted from LJ Sonic's PRNG library
-- i am so fucking sorry
-- this is the only way i found to get random elements to sync in replays, please fix in 2.0 thanks

local fr_prng = CV_RegisterVar({
	name = "fr_prng",
	defaultvalue = "0/6278/975/39207/45678/@",
	flags = CV_NETVAR,
	possiblevalue = nil
})

-- initial values are magic numbers from the other script lol
local fr_prng_local_t = 0
local fr_prng_local_x = 6278
local fr_prng_local_y = 975
local fr_prng_local_z = 39207
local fr_prng_local_w = 45678

-- evil bit shift fuckery
local function N_Random()
	fr_prng_local_t = fr_prng_local_x ^^ (fr_prng_local_x << 11)
	fr_prng_local_x, fr_prng_local_y, fr_prng_local_z, fr_prng_local_w = fr_prng_local_y, fr_prng_local_z, fr_prng_local_w, fr_prng_local_w ^^ (fr_prng_local_w >> 19) ^^ fr_prng_local_t ^^ (fr_prng_local_t >> 8)
	return fr_prng_local_w
end

-- then we reimplement every baseline random function so i can find and replace them all
local function N_RandomKey(n)
    return abs(N_Random() % n)
end
local function N_RandomRange(a, b)
    return a + abs(N_Random() % (b - a + 1))
end
local function N_RandomDatas()
    return d
end

//kartstuff and hardcode constants for performance reasons --freeman
//due to snu being a wizard they figured out defining these as locals is much faster
//performance-wise to reference instead of letting hardcode lookup the value
//thank you based snu and associates

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT

local k_position = k_position
local k_invincibilitytimer = k_invincibilitytimer
local k_sneakertimer = k_sneakertimer
local k_pogospring = k_pogospring
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_spinouttimer = k_spinouttimer
local k_aizdriftstrat = k_aizdriftstrat
local k_itemblink = k_itemblink
local k_itemblinkmode = k_itemblinkmode
local k_itemroulette = k_itemroulette
local k_itemtype = k_itemtype
local k_itemamount = k_itemamount
local k_itemheld = k_itemheld
local k_roulettetype = k_roulettetype
local k_stolentimer = k_stolentimer
local k_stealingtimer = k_stealingtimer
local k_eggmanexplode = k_eggmanexplode
local k_rocketsneakertimer = k_rocketsneakertimer

//I jammed all of these into a table because lol thinkframe has more than 60 upvalues thanks lua very cool
local fr = {
	bluescore = 0, -- team score values are ephemeral until finish conditions are met, which forces a recalc
	orangescore = 0, -- so you can probably do whatever you want with this
	bluename = "DON'T WORRY ABOUT THIS", -- this is nice because it lets me instantly know when the script bailed in team generation
	orangename = "IT'S PROBABLY FINE?", -- but you should probably never see it
	localplayer = nil, -- UHHHHHHHHHH
	consoleprefix = "\131",
	blowout = false, -- are we in a fatal ko? should we do things that fatal kos do?
	fakepostracemusic = 0, -- this timer delays fatal music so kart doesn't immediately stomp on it with an audio file padded by 10 seconds of silence (thanks)
	doteamstuff = true,
	bossmode = false,
	bossplayer = nil, -- gotta keep track of who the boss is to apply boss-specific mechanics
	bossfocused = "@", -- the player currently being watched for boss selection; if fr_bosschance = 100 this makes them unpickable, if fr_bosschance < 100 it forces them to be picked
	bossrestock = true, -- whether boss should be given bonus item stock (true unless they've already received it for this pull)
	helpfuladvice = 1, -- random index for postrace tips
	ffasnark = 1, -- random index for FFA subtitle
	finalrecalc = false, -- have we locked in final scores?
	bossgotemname = nil, -- who last nailed the boss?
	bossprotect = false, -- is the boss receiving a pity item after a hit?
	bossgotemposition = 15, -- where was the boss when they got hit?
	bossgotemtimer = 0, -- hud timer for ghetto boss killfeed
	prettyposition = {"1st", "2nd", "3rd", "4th", "5th", "6th", "7th", "8th", "9th", "10th", "11th", "12th", "13th", ":|", ":[", ">:["},
	savedtheworld = nil, -- should we do special celebrations for 1 player beating a boss, or leader bonus deciding a normal teams game?
	restorecolors = true, -- have we written colors back to teams-mode players during intermission yet? (gotta preserve personal colors for mixed games)
	slipdistance = 0,
	slipgrace = TICRATE*3,
	elimon = false //if elim is loaded
	}

-- just in case.
local function sanitizebossname(s)
	return s:gsub("%W", "")
end

-- serialize prng state to a cvar so that replays can read it
local function N_WriteRandomToCVars()
	COM_BufInsertText(server, 'fr_prng "'..fr_prng_local_t.."/"..fr_prng_local_x.."/"..fr_prng_local_y.."/"..fr_prng_local_z.."/"..fr_prng_local_w.."/"..sanitizebossname(fr.bossfocused)..'"')
end

-- deserlialize prng state from a cvar so that replays sync
local function N_ReadRandomFromCVars()
	local t = {}
	for str in string.gmatch(fr_prng.string, "([^\/]+)") do
		table.insert(t, str)
	end
	fr_prng_local_t = t[1]
	fr_prng_local_x = t[2]
	fr_prng_local_y = t[3]
	fr_prng_local_z = t[4]
	fr_prng_local_w = t[5]
	fr.bossfocused = t[6]
end

addHook("NetVars", function(net)
	fr.bluename = net(fr.bluename)
	fr.orangename = net(fr.orangename)
	fr.blowout = net(fr.blowout)
	fr.fakepostracemusic = net(fr.fakepostracemusic)
	fr.doteamstuff = net(fr.doteamstuff)
	fr.bossmode = net(fr.bossmode)
	fr.bossplayer = net(fr.bossplayer)
	fr.helpfuladvice = net(fr.helpfuladvice)
	fr.finalrecalc = net(fr.finalrecalc)
	fr.ffasnark = net(fr.ffasnark)
	fr.bossfocused = net(fr.bossfocused)
	fr.bossrestock = net(fr.bossrestock)
	fr.bossgotemname = net(fr.bossgotemname)
	fr.bossgotemposition = net(fr.bossgotemposition)
	fr.bossgotemtimer = net(fr.bossgotemtimer)
	fr.bossprotect = net(fr.bossprotect)
	fr.restorecolors = net(fr.restorecolors)
	fr_prng_local_t = net(fr_prng_local_t)
	fr_prng_local_x = net(fr_prng_local_x)
	fr_prng_local_y = net(fr_prng_local_y)
	fr_prng_local_z = net(fr_prng_local_z)
	fr_prng_local_w = net(fr_prng_local_w)
	fr.elimon = net(fr.elimon)
	fr.slipdistance = net(fr.slipdistance)
	fr.slipgrace = net(fr.slipgrace)
end)

-- allocate sounds
freeslot("sfx_mugen") -- FATAL KO
freeslot("sfx_fatal") -- fatal music
freeslot("sfx_frboss") -- boss announcement
freeslot("sfx_fmssb0") -- generic game mode announcement
freeslot("sfx_fmffa") -- FREE FOR ALL
freeslot("sfx_fmteam") -- TEAM BATTLE
freeslot("sfx_fmdblk") -- teams mode tie (DOUBLE KO!)
freeslot("sfx_fmbshc") -- hitconfirm on boss
freeslot("sfx_fmpnch") -- pinch hitconfirm on winning boss
freeslot("sfx_fmstw") -- clutch win: saved the world!

local FRteams = {
	{blue = "BLUE", orange = "ORANGE", noflip = true},
	{blue = "REI", orange = "ASUKA", noflip = true},
	{blue = "ROBOT GIRLS", orange = "SWORD GIRLS"},
	{blue = "im gay", orange = "i've gay"},
	{blue = "SPRITES", orange = "MODELS"},
	{blue = "SHORTCUT RESPECTERS", orange = "FEARLESS LAWNMOWERS"},
	{blue = "SWEET BRO", orange = "HELLA JEFF"},
	{blue = "OMLETTE DU FROMAGE", orange = "VODKA CYKA BLYAD"},
	{blue = "MYTHRA", orange = "PYRA", noflip = true},
	{blue = "HUMANITY", orange = "MONKE"},
	{blue = "BILLY MAYS", orange = "PHIL SWIFT", noflip = true},
	{blue = "1 WEIGHT", orange = "9 WEIGHT"},
	{blue = "LEFT ON TOXIC PALACE", orange = "RIGHT ON TOXIC PALACE"},
	{blue = "PRO-SKUB", orange = "ANTI-SKUB"},
	{blue = "SRB2KART", orange = "DRRR"},
	{blue = "FRIENDMOD", orange = "PALSCRIPT"},
	{blue = "LIGHTNING ROUND", orange = "ROLLING THUNDER"},
	{blue = "SUGOI", orange = "A-MEOWS-ING"},
	{blue = "KABAN & SERVAL", orange = "RACOON & FENNEC"},
	{blue = "JAPARI BUS", orange = "JAPARI SEDAN"}
}

local FRtips = {
	{first = "Throw your weight around!", second = "A sacrificial bump can help nearby teammates get ahead."},
	//{first = "A poorly-timed Grow can trash your teammates.", second = "Be careful on dash panels and springs!"},
	{first = "Be careful around lightweight teammates.", second = "It doesn't take much to send them into walls!"},
	{first = "Be careful with deployed items.", second = "Deploy while stationary, and you could catch a teammate by surprise!"},
	//{first = "Remember to congratulate your teammates on a job well done!", second = ""},
	{first = "If your teammates are holding defensive items, give them some room to set traps.", second = ""},
	//{first = "Everyone makes mistakes.", second = "Don't get too upset over it - there's always next round."},
	{first = "The Look Backward button is a powerful tool.", second = "If a teammate has a speed item, make space for them!"},
	{first = "The SPB supercharges 2nd place's items.", second = "Save it to help an ally take the lead!"},
	{first = "When allies are frontrunning, holding the SPB keeps them safe while they pull ahead.", second = ""},
	{first = "Jawz targeting is twitchy and unforgiving.", second = "Keep steady and fire with care!"},
	{first = "See a teammate's Jawz reticle on you?", second = "Pull away from enemies to give them a clear shot."},
	//{first = "Don't complain about your team.", second = "Everyone's trying their best."},
	{first = "Always give it your all.", second = "Your team is counting on you!"},
	{first = "Orbinauts travel faster than Jawz.", second = "Use them to save teammates with style!"},
	//{first = "The Ball Hog can cause huge collateral damage.", second = "For best results, point-blank an enemy and pray!"},
	{first = "Hyuudoro doesn't care what team you're on.", second = "With luck, you can coordinate to smuggle items far ahead..."},
	{first = "Don't hit your allies with the sink.", second = "I know, it's tempting."},
	{first = "Mines laid behind you arm very slowly.", second = "With teammates nearby, it's often safer than throwing them."},
	//{first = "When using Invincibility, focusing on enemies can help your allies overtake.", second = ""},
	//{first = "Don't be selfish with Invincibility and Grow!", second = "Plowing through allies to save time costs you more than it gains."},
	//{first = "Eggbox explosions linger for a long time.", second = "If you have one, pull FAR away from your team!"},
	{first = "Your teammates have an arrow over their heads, no matter what color you are.", second = "Having trouble telling friend from foe? Use \135fr_colorhelp\128 to override in-game colors."},
	{first = "i've gay", second = ""},
	{first = "Bump spinning teammates forward to minimize the damage.", second = ""},
	{first = "Holding 1st and 2nd place nearly guarantees a win.", second = "If you're feeling brave, SPB Rush can help a duo leave everyone behind..."},
	{first = "It's not over until it's over.", second = "Fight until the very end - a single mistake could change everything!"},
	{first = "When you're on track for a shutout, your team score will flash rapidly.", second = "Win without giving up points for a FATAL KO."},
	//{first = "There are few things in life like an intense rivalry.", second = "Get friends and foes together for crew battles!"},
	{first = "Overtaking an enemy is worth 2 points, no matter where it happens.", second = "Even if you're far behind, one pass could make a difference."},
	{first = "Be careful with tricky eggbox placement!", second = "If a teammate doesn't see you place it, they might be the one that gets hit..."},
	{first = "Carrying your team? Wish you could ditch the deadweight?", second = "Consistently place high, and you might get your wish..."},
	{first = "Teamslip enabled? Charge a draft boost off your teammate.", second = "Bump into them when charged and stay close to keep up both your slipstreams!"},
	{first = "Team tags enabled? Set your name or clan to the tag displayed.", second = "You'll be auto-assigned to that side so you can play with your friends."}
}

local FRffa = {
	"Cutthroat, god-fearing Kart racing. Good luck!",
	"TEAM MODE IS SUCKS",
	"It's just a game of who gets memed by the ramp first.",
	"HA HA TIME FOR JAWZ",
	"[bass-boosted SPB noise]",
	"Every man, woman, robot, furry, or vertically oriented car for themselves.",
	"Slope physics are your only friend now.",
	"No friends. Only fear.",
	"Recommended for those with antisocial tendencies.",
	"Who needs the power of friendship anyway?",
	"Hey, at least it's not poker.",
	"Don't hold back. Crush anyone between you and victory!",
	"You are alone. Make the most of it.",
	"Wow, a lone wolf. This person must be really cool.",
	"HELP I'M TRAPPED IN A SNARKY RANDOMIZED MESSAGE FACTORY",
	"NOW! Hit it very hard!",
	"Get hype, throw items, kill God.",
	"It all depends on your skill! (And bumpcode)",
	"Ready your ragespecs. An all-out brawl!",
	"YOU get an Orbinaut, and YOU get an Orbinaut, and YOU...",
	"You ever just die?",
	"Now with 100% less mustard gas.",
	"brb chatbug",
	"[violent horn spam]",
	"Come on, get serious!",
	"The wheel of jank is turning!",
	"YOU GOT INSANITY.",
	"You have selected POWER DRIVE.",
	"Race to the finish!",
	"LET'S GO JUSTIN",
	"To switch to teams mode, press Alt+F4.",
	"Honk if you love solitude.",
	"TIP: Don't choke your rocket start.",
	"You'd better get ready to die.",
	"Is it too late to double-check your controller battery?",
	"Recurring Kart Effect...",
	"Brace for syncfails.",
	"TODO: WRITE MORE OF THESE",
	"stop do kick",
	"Gameplay identical to everyone on your team with friendly fire on.",
	"OBJECTIVE: SURVIVE",
	"TODO: FIX SCRIPT RANDOMLY BANNING LAST PLACE",
	"FREE FOR ALL MODE IS SUCKS",
	"TIP: Hold accelerate when '2' appears to automatically spinout.",
	"Team mode but with more teams",
	"Jolly Non-cooperation",
	"Use 'map mapfn' for a surprise",
	"how i drov kart??",
	"Press Custom 1 to do nothing!",
	"why did you vote for this track"
}

local FRbosstitles = { -- listen, don't even ask about the way this is formatted, it made sense at the time
	{pre = "Omega", suf = ""},
	{pre = "Shin", suf = ""},
	{pre = "Dark", suf = ""},
	{pre = "Evil", suf = ""},
	{pre = "Not", suf = ""},
	{pre = "Gold", suf = ""},
	{pre = "Serious", suf = ""},
	{pre = "Literally", suf = ""},
	{pre = "SSJ3", suf = ""},
	{pre = "Awakened", suf = ""},
	{pre = "Super", suf = "II Turbo"},
	{pre = "", suf = "And Smough"},
	{pre = "", suf = "With A Gun"},
	{pre = "Perfect", suf = ""},
	{pre = "", suf = ", The Lonely", nospace = true},
	{pre = "Punished", suf = ""},
	{pre = "Reformed", suf = ""},
	{pre = "Activated", suf = ""},
	{pre = "Devil", suf = ""},
	{pre = "", suf = "With Angry Eyebrows"},
	{pre = "Orbinaut God", suf = ""},
	{pre = "Airshot God", suf = ""},
	{pre = "Palette Swap", suf = ""},
	{pre = "", suf = ", Sniper Extraordinaire", nospace = true},
	{pre = "", suf = ", Never Lucky", nospace = true},
	{pre = "", suf = ", Unironic Joker Main", nospace = true},
	{pre = 'Mike "', suf = '" Ross', nospace = true, noprespace = true},
	{pre = 'Ayman "', suf = '" Saria', nospace = true, noprespace = true},
	{pre = "", suf = "SP",},
	{pre = "", suf = "EX",},
	{pre = "", suf = ", F.O.E!", nospace = true},
	{pre = "DUDE", suf = "LMAO"},
	{pre = "Violent", suf = ""},
	{pre = "", suf = "And Knuckles"},
	{pre = "Rare", suf = ""},
	{pre = "", suf = "++", nospace = true},
	{pre = "", suf = ", Vindicator", nospace = true},
	{pre = "XF3", suf = ""},
	{pre = "Fallen Hero", suf = ""},
	{pre = "Shirtless", suf = ""},
	{pre = "", suf = "Prime"},
	{pre = "", suf = "Black"},
	{pre = "", suf = ", Edgelord Supreme", nospace = true},
	{pre = "Unlimited", suf = ""},
	{pre = "Revolver", suf = ""},
	{pre = "", suf = "the Fallen"},
	{pre = "", suf = "Phase 2"},
	{pre = "", suf = ", Three Lap Magic", nospace = true},
	{pre = "Well-Rested", suf = ""},
	{pre = "", suf = ", THE ABADDON FIGHTER", nospace = true},
	{pre = "", suf = ".EXE", nospace = true},
	{pre = "Masked", suf = ""},
	{pre = "Pink Gold", suf = ""},
	{pre = "", suf = "After A Balanced Breakfast"},
	{pre = "", suf = ", WiFi Warrior", nospace = true},
	{pre = "Tom Clancy's", suf = ""},
	{pre = "", suf = ", A Hideo Kojima Production", nospace = true},
	{pre = "", suf = "Platinum"},
	{pre = "", suf = ", Gamebreaker", nospace = true},
	{pre = "", suf = ", Danmaku Legend", nospace = true},
	{pre = "SD", suf = ""},
	{pre = "Stylish Mode", suf = ""},
	{pre = "", suf = ", Bootshine Hero", nospace = true},
	{pre = "Lingering", suf = ""},
	{pre = "", suf = "From Streets"},
	{pre = "", suf = ", Avatar Of Sorrow", nospace = true},
	{pre = "", suf = "300%"},
	{pre = "K-Groove", suf = ""},
	{pre = "", suf = "(Using Tilt Controls)"},
	{pre = "Chatbugged", suf = ""},
	{pre = "Orochi", suf = ""},
	{pre = "", suf = ", Jawzbringer", nospace = true},
	{pre = "", suf = "'s Little Sister", nospace = true},
	{pre = "LV. 999", suf = ""},
	{pre = "Endless Witch", suf = ""},
	{pre = "twitch.tv/", suf = "", noprespace = true},
	{pre = "Gay Pink", suf = ""},
	{pre = "", suf = "left the game (Synch Failure)"},
}

local function FRlog(p, q) -- debug
	if not fr_debug.value then
		return
	end
	if not p then
		print("FRIENDMOD: HEY MORON, YOU PUT AN INVALID PLAYER INTO A DEBUG PRINT: "..q)
	end
	if not p.name then
		print("FRIENDMOD: HEY MORON, YOU PUT A NON-PLAYER INTO A DEBUG PRINT: "..q)
	end
	print("FRIENDMOD: "..p.name.." >> "..q)
end

local function incomingblowout()
	return fr.bluescore == 0 or fr.orangescore == 0
end

local function supervalid(p)
	return p.FRready and p.mo and (not p.spectator)
end

local function realblue()
	return fr_bluecolorlocal.value and fr_bluecolorlocal.value or fr_bluecolor.value
end

local function realorange()
	return fr_orangecolorlocal.value and fr_orangecolorlocal.value or fr_orangecolor.value
end

local function realskincolor(p)
	if p.FRteam == 1
		return realblue()
	elseif p.FRteam == 2 then
		return realorange()
	else
		return p.skincolor
	end
end

local function blueprefix() -- SHUT UP SHUT UP SHUT UP
	if fr_bluecolorlocal.value
		return colLookup[fr_bluecolorlocal.value]
	end
	return colLookup[fr_bluecolor.value]
end

local function orangeprefix() -- NIGHTMARE NIGHTMARE NIGHTMARE NIGHTMARE
	if fr_orangecolorlocal.value
		return colLookup[fr_orangecolorlocal.value]
	end
	return colLookup[fr_orangecolor.value]
end

local function enemyprefix(x)
	return (x == 1) and orangeprefix() or blueprefix()
end

local function countactive()
	local count = 0
	for p in players.iterate
		if not p.spectator then
			count = $ + 1
		end
	end
	return count
end

local function countblue()
	local bluecount = 0
	for p in players.iterate
		if p.FRteam == 1 then
			bluecount = $ + 1
		end
	end
	return bluecount
end

local function countorange()
	local orangecount = 0
	for p in players.iterate
		if p.FRteam == 2 then
			orangecount = $ + 1
		end
	end
	return orangecount
end

local function finished(p)
	if G_BattleGametype() and p.kartstuff[k_bumper] == 0 then
		return true
	end
	if p.spectator or (not p.mo) then
		return true
	elseif p.pflags & PF_TIMEOVER then
		return true
	elseif p.exiting then
		return true
	end
	return false
end

local function bluefinished()
	for p in players.iterate
		if p.FRteam == 1 and not finished(p)  then
			return false
		end
	end
	return true
end

local function bluenotfinished()
	for p in players.iterate
		if p.FRteam == 1 and finished(p)  then
			return false
		end
	end
	return true
end

local function orangefinished()
	for p in players.iterate
		if p.FRteam == 2 and not finished(p)  then
			return false
		end
	end
	return true
end

local function orangenotfinished()
	for p in players.iterate
		if p.FRteam == 2 and finished(p)  then
			return false
		end
	end
	return true
end

local function allfinished()
	for p in players.iterate
		if not finished(p) then
			//print(p.name.." not finished fucking off")
			return false
		end
	end
	//print("LOOKGUYSLOOK===ALLFINISHED IS TRUE")
	return true
end

local function teamname(p)
	return (p.FRteam == 1) and fr.bluename or fr.orangename
end

local function enemyname(p)
	return (p.FRteam == 1) and fr.orangename or fr.bluename
end

local function teamprefix(p)
	return (p.FRteam == 1) and blueprefix() or orangeprefix()
end

local function enemyprefix(p)
	return (p.FRteam == 1) and orangeprefix() or blueprefix()
end

local function bluenameoverride()
	return fr_bluename.string != "Random" or fr_bluetag
end

local function bluetag()
	return fr_bluename.string == "Random" and fr_bluetag != nil and fr_bluetag != "" //FUCK
end

local function blueskin()
	return fr_blueskin != nil and fr_blueskin != ""
end

local function orangeskin()
	return fr_orangeskin != nil and fr_orangeskin != ""
end

local function orangenameoverride()
	return fr_orangename.string != "Random" or fr_orangetag
end

local function orangetag()
	return fr_orangename.string == "Random" and fr_orangetag != nil and fr_orangetag != "" //SHUT UP
end

local function teamstied()
	if fr.bossmode then
		return (fr.bluescore == 1)
	else
		return (fr.bluescore == fr.orangescore)
	end
end

local function postteamassign(p)
	if not p or not p.valid then return end
	local skincheck = nil
	if blueskin() and p.FRteam == 1 and not p.frskinoptout then
		skincheck = skins[fr_blueskin.string]
		if skincheck != nil then
			R_SetPlayerSkin(p, fr_blueskin.string)
		//p.mo.skin = fr_blueskin.string
		//p.skin = skins[fr_orangeskin.string] or skins["sonic"]
			chatprintf(p, "TEAM SKIN: '"..blueprefix()..fr_blueskin.string.."\128'. (Use '\130fr_skinoptout\128' in console to use your own)")
		end
	end
	if orangeskin() and p.FRteam == 2 and not p.frskinoptout then
		skincheck = skins[fr_orangeskin.string]
		if skincheck != nil then
			R_SetPlayerSkin(p, fr_orangeskin.string)
		//p.mo.skin = fr_orangeskin.string
		//p.skin = skins[fr_orangeskin.string] or skins["sonic"]
			chatprintf(p, "TEAM SKIN: '"..orangeprefix()..fr_orangeskin.string.."\128'. (Use '\130fr_skinoptout\128' in console to use your own)")
		end
	end
end

local function assignteam(p, team)
	p.FRteam = team
	FRlog(p, "Assigned to team "..p.FRteam)
	postteamassign(p)
	--chatprintf(p, p.name..", you are on "..teamname(p).."! Defeat "..enemyname(p).."!", true)
end

local function teamwinning(p)
	if fr.bossmode then
		if G_BattleGametype() and bluenotfinished() then
			return true
		elseif fr.bluescore == 1 then
			return true
		end
		if p.FRteam == 1 and fr.bluescore > 0 then
			return true
		elseif p.FRteam == 2 and fr.bluescore == 0 then
			return true
		end
		return false
	end
	if (p.FRteam == 1 and fr.bluescore > fr.orangescore) or (p.FRteam == 2 and fr.orangescore > fr.bluescore) then
		return true
	end
	return false
end

local function winningprefix()
	return (fr.bluescore > fr.orangescore) and blueprefix() or orangeprefix()
end

local function autoassignteam(p, ...)
	if p.FRteam then
		FRlog(p, "Already assigned a team")
		return
	end
	if p.spectator then
		FRlog(p, "*** WHY ARE YOU GIVING A SPECTATOR A TEAM *** ")
		//p.FRteam = nil
		return
	end
	if fr.bossmode then
		FRlog(p, "fr.bossmode lol, go to blue")
		assignteam(p, 1)
		chatprintf(p, "<SERVER> You were assigned to "..blueprefix()..teamname(p).." \128 to fight against "..orangeprefix().."THE BOSS\128.")
		return
	end
	if fr_crewbattle.value then
		FRlog(p, "Crews are on")
		local matchedbluecrew = nil
		local matchedorangecrew = nil
		if bluenameoverride() then
			local matchstring = ""
			if bluetag() and string.len(fr_bluetag.string)>0 then matchstring = fr_bluetag.string else matchstring = fr_bluename.string end
			matchedbluecrew = string.find(string.lower(p.name), string.lower(matchstring), 1, true)
			if not matchedbluecrew and p.HMclan then
				matchedbluecrew = string.find(string.lower(p.HMclan), string.lower(matchstring), 1, true)
			end
		end
		if orangenameoverride() then
			local matchstring = ""
			if orangetag() and string.len(fr_orangetag.string)>0 then matchstring = fr_orangetag.string else matchstring = fr_orangename.string end
			matchedorangecrew = string.find(string.lower(p.name), string.lower(matchstring), 1, true)
			if not matchedorangecrew and p.HMclan then
				matchedorangecrew = string.find(string.lower(p.HMclan), string.lower(matchstring), 1, true)
			end
		end
		if bluenameoverride() then
			if matchedbluecrew then
				FRlog(p, "Crew assigning to team 1")
				assignteam(p, 1)
				if bluetag() then
					chatprintf(p, "<SERVER> You were assigned to "..blueprefix()..teamname(p).." \128because you match its tag ("..blueprefix()..fr_bluetag.string.."\128).")
				else
					chatprintf(p, "<SERVER> You were assigned to "..blueprefix()..fr_bluename.string.." \128because you match its name.")
				end
				return
			end
		end
		if orangenameoverride() then
			if matchedorangecrew then
				FRlog(p, "Crew assigning to team 2")
				assignteam(p, 2)
				if orangetag() then
					chatprintf(p, "<SERVER> You were assigned to "..orangeprefix()..teamname(p).." \128because you match its tag ("..orangeprefix()..fr_orangetag.string.."\128).")
				else
					chatprintf(p, "<SERVER> You were assigned to "..orangeprefix()..fr_orangename.string.." \128because you match its name.")
				end
				return
			end
		end
		if not fr_crewfill.value then
			FRlog(p, "Crewfill disabled")
			if ((bluenameoverride() and not orangenameoverride()) or (bluetag() and not orangetag())) and not matchedbluecrew then
				FRlog(p, "Force pushing to team 2")
				assignteam(p, 2)
				chatprintf(p, "<SERVER> You were pushed to "..orangeprefix()..fr_orangename.string.." because you didn't match the crew of the other team.")
				return
			elseif ((orangenameoverride() and not bluenameoverride()) or (orangetag() and not bluetag())) and not matchedorangecrew then
				FRlog(p, "Force pushing to team 1")
				assignteam(p, 1)
				chatprintf(p, "<SERVER> You were pushed to "..blueprefix()..fr_bluename.string.." because you didn't match the crew of the other team.")
				return
			end
		end
		FRlog(p, "...but didn't match a crew")
	end
	if ... then
		FRlog(p, "team assign early out, doing crews first")
		return
	end
	if countblue() == countorange() then
		FRlog(p, "Team assigned randomly")
		assignteam(p, N_RandomRange(1, 2))
		chatprintf(p, "<SERVER> You were randomly assigned to "..teamprefix(p)..teamname(p).."\128.")
	else
		FRlog(p, "Team imbalance")
		if countblue() > countorange() then
			assignteam(p, 2)
		else
			assignteam(p, 1)
		end
		chatprintf(p, "<SERVER> You were randomly assigned to "..teamprefix(p)..teamname(p).."\128.")
	end
end

local function bossflash()
	fr.bossplayer.kartstuff[k_itemblink] = TICRATE
	fr.bossplayer.kartstuff[k_itemblinkmode] = 2
	S_StartSoundAtVolume(nil, sfx_itrolk, 255, fr.bossplayer)
	S_StartSoundAtVolume(nil, sfx_ruby2, 255, fr.bossplayer)
end

local function welcometofuckingdie(p)
	p.pflags = $|PF_TIMEOVER
	P_DamageMobj(p.mo, nil, nil, 10000)
	S_StartSound(p.mo, sfx_kc3b)
	K_SpawnMineExplosion(p.mo, p.skincolor)
	P_DamageMobj(p.mo, nil, nil, 10000)
end

local function doframeshit(p)
	if not p.mo then return end//TODO: these are okay but still probably bad 12-24-2020
	local mobj = p.FRoverhead
	local flicker = false
	if not mobj.tracer then
		return
	end
	if G_BattleGametype() then
		p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
		mobj.tracer.flags2 = $|MF2_DONTDRAW
		return
	end
	if p.kartstuff[k_itemroulette] and not G_BattleGametype() then -- i am here to duplicate vanilla game behavior, not ask questions.
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|(((mobj.target.player.kartstuff[k_itemroulette] % (13*3)) / 3) + 1)
	elseif p.kartstuff[k_stolentimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
		flicker = true
	elseif p.kartstuff[k_stealingtimer] > 0 and (leveltime % 2) then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_HYUDORO
	elseif p.kartstuff[k_eggmanexplode] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_EGGMAN
		flicker = true
	elseif p.kartstuff[k_rocketsneakertimer] > 1 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_ROCKETSNEAKER
		flicker = true
	elseif p.kartstuff[k_growshrinktimer] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		mobj.tracer.sprite = SPR_ITEM
		mobj.tracer.frame = FF_FULLBRIGHT|KITEM_GROW
	elseif p.kartstuff[k_itemtype] and p.kartstuff[k_itemamount] > 0 then
		mobj.state = S_PLAYERARROW_BOX
		if p.kartstuff[k_itemtype] == KITEM_ORBINAUT then
			mobj.tracer.sprite = SPR_ITMO
			mobj.tracer.frame = FF_FULLBRIGHT|(min(mobj.target.player.kartstuff[k_itemamount]-1, 3))
		elseif p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY then
			mobj.tracer.sprite = SPR_ITMI
			mobj.tracer.frame = FF_FULLBRIGHT|((leveltime % (7*3)) / 3)
		elseif p.kartstuff[k_itemtype] == KITEM_SAD
			mobj.tracer.sprite = SPR_ITEM
			mobj.tracer.frame = FF_FULLBRIGHT
		else
			p.FRoverhead.tracer.sprite = SPR_ITEM
			p.FRoverhead.tracer.frame = FF_FULLBRIGHT|(p.kartstuff[k_itemtype])
		end
		if p.kartstuff[k_itemheld] then
			flicker = true
		end
	else
		p.FRoverhead.state = S_PLAYERARROW
		p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
	end
	if flicker then
		if leveltime % 2 then
			-- p.FRoverhead.tracer.flags2 = $ & (~MF2_DONTDRAW)
		else
			p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
		end
	end
end

local function spawnoverhead(p)
	if not p.mo then return end
	p.FRoverhead = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p)+16*FRACUNIT, MT_PLAYERARROW)
	p.FRoverhead.target = p.mo
end

local function spawnwanted(p)
	if not p.mo then return end
	p.FRwanted = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p)+16*FRACUNIT, MT_PLAYERWANTED)
	p.FRwanted.target = p.mo
end

local function FYShuffle(tInput)
	local tReturn = {}
    for i = #tInput, 1, -1 do
        local j = N_RandomRange(1, i)
        tInput[i], tInput[j] = tInput[j], tInput[i]
        table.insert(tReturn, tInput[i])
    end
    return tReturn
end

local function buildbossteamname(p)
	FRlog(p, "building boss name")
	local bosstitle = N_RandomRange(1, #FRbosstitles)
	local bossconditionalspace = FRbosstitles[bosstitle].nospace and "" or " "
	local bossconditionalprespace = FRbosstitles[bosstitle].noprespace and "" or " "
	if bossconditionalspace and FRbosstitles[bosstitle].suf == "" then
		bossconditionalspace = ""
	end
	if bossconditionalprespace and FRbosstitles[bosstitle].pre == "" then
		bossconditionalprespace = ""
	end
	local formattedname = string.gsub(p.name, ".*| ?", "")
	return FRbosstitles[bosstitle].pre..bossconditionalprespace..formattedname..bossconditionalspace..FRbosstitles[bosstitle].suf
end

local function becometheboss(p)
	FRlog(p, "promoting to boss")
	if countorange() != 0 then
		FRlog(p, "but there's already a boss??")
		return
	end
	fr.orangename = buildbossteamname(p)
	assignteam(p, 2)
	fr.bossplayer = p
	p.FRlastboss = true
end

COM_AddCommand("fr_srreset",function(p)
	if not fr_scorereport.value then
		CONS_Printf(p, "\133Score report for FRIENDMOD is not on. \128But the round number and scores were reset to 1 anyways.")
	end
	print("Score report round number and scores were reset.")
	server.roundnumber = 1
	server.bluetotalscore = 0
	server.orangetotalscore = 0
end, 1)

COM_AddCommand("fr_srround",function(p, numrounds)
	if not numrounds then
		CONS_Printf(p, "Current round: "..server.roundnumber)
		CONS_Printf(p, "\133Usage: \128'fr_scorereportround <round number>' (will set the current round to the provided number)")
		return
	end
	local nr = tonumber(numrounds)
	if not nr or nr <= 0 then
		CONS_Printf(p, "\133***WHAT ARE YOU TRYING TO DO***") //I liked this format a lot that tyron used, bless him
		return
	end
	if not fr_scorereport.value then
		CONS_Printf(p, "\133Score report for FRIENDMOD is not on. \128But the round number for scores was set to "..numrounds.." anyways.")
	end
	print("Round number was set to "..numrounds.." manually.")
	server.roundnumber = nr
end, 1)

COM_AddCommand("fr_srbluescore",function(p, newscore)
	if not newscore then
		CONS_Printf(p, "TEAM "..blueprefix()..fr.bluename.."'s\128 current total score: "..server.bluetotalscore)
		CONS_Printf(p, "\133Usage: \128'fr_srbluescore <number>' (will set blue's current grand total score to number provided)")
		return
	end
	local ns = tonumber(newscore)
	if not ns or ns <= 0 then
		CONS_Printf(p, "\133***WHAT ARE YOU TRYING TO DO***")
		return
	end
	if not fr_scorereport.value then
		CONS_Printf(p, "\133Score report for FRIENDMOD is not on. \128But the grand total score for blue team was set to "..newscore.." anyways.")
	end
	print("TEAM "..blueprefix()..fr.bluename.."'s\128 grand total score was set to "..newscore)
	server.bluetotalscore = ns
end, 1)

COM_AddCommand("fr_srorangescore",function(p, newscore)
	if not newscore then
		CONS_Printf(p, "TEAM "..orangeprefix()..fr.orangename.."'s\128 current total score: "..server.orangetotalscore)
		CONS_Printf(p, "\133Usage: \128'fr_srorangescore <number>' (will set orange's current grand total score to number provided)")
		return
	end
	local ns = tonumber(newscore)
	if not ns or ns <= 0 then
		CONS_Printf(p, "\133***WHAT ARE YOU TRYING TO DO***")
		return
	end
	if not fr_scorereport.value then
		CONS_Printf(p, "\133Score report for FRIENDMOD is not on. \128But the grand total score for orange team was set to "..newscore.." anyways.")
	end
	print("TEAM "..orangeprefix()..fr.orangename.."'s\128 grand total score was set to "..newscore)
	server.orangetotalscore = ns
end, 1)


local function FRinit(p)
	FRlog(p, "initalizing")
	p.FRteam = nil
	p.FRfinished = nil
	p.FRstasis = nil
	p.FRoneframedelay = nil -- AAAAAAAAAAAAAAA
	p.FRreprisal = 0
	p.FRoverhead = nil
	p.FRwanted = nil
	p.personalscore = 0
	p.exiting = 0
	p.FRready = true
	p.FRlastboss = p.FRlastboss or false
	p.FRoldskincolor = p.skincolor
	p.kartstuff[k_roulettetype] = 0
	p.FRlastframeitem = 0
	p.FRsliptarget = nil //points to a cooperating player for team slipstream effect
	p.FRtargetdistance = 0 //saved distance between you and slip partner for HUD display
	p.FRslipgrace = 0 //timer of the slipstream grace period
	p.FRslipvisual = false //if slip visuals have been handled for this player this tic (reduce overhead)
end

local function fr_randomtoggle(p, ...)
	local consolearg = (N_RandomRange(0, 1) and "on" or "off")
	COM_BufInsertText(server, "fr_enabled "..consolearg)
	CONS_Printf(p, fr.consoleprefix.."Teams are now "..consolearg)
end
COM_AddCommand("fr_randomtoggle", fr_randomtoggle, 1)

local function fr_changeblue(p, ...)
	for q in players.iterate
		if string.find(string.lower(q.name), string.lower(...), 1, true) then
			q.FRteam = 1
			CONS_Printf(p, fr.consoleprefix..q.name.." set to blue team")
			return
		end
	end
	CONS_Printf(p, fr.consoleprefix.."Couldn't find a player to reassign")
end
COM_AddCommand("fr_changeblue", fr_changeblue, 1)

local function fr_changeorange(p, ...)
	for q in players.iterate
		if string.find(string.lower(q.name), string.lower(...), 1, true) then
			q.FRteam = 2
			CONS_Printf(p, fr.consoleprefix..q.name.." set to orange team")
			return
		end
	end
	CONS_Printf(p, fr.consoleprefix.."Couldn't find a player to reassign")
end
COM_AddCommand("fr_changeorange", fr_changeorange, 1)

local function fr_manualsave(p, ...) -- mostly for testing
	N_WriteRandomToCVars()
	CONS_Printf(p, fr.consoleprefix.."Saving replay state")
end
COM_AddCommand("fr_manualsave", fr_manualsave, 1)

local function fr_colorhelp(p, ...)
	CONS_Printf(p, fr.consoleprefix.."Use fr_bluecolorlocal and fr_orangecolorlocal to change team colors.")
	CONS_Printf(p, fr.consoleprefix.."If you want those settings to automatically load, place them in a file called 'friendmod.cfg' in your Kart/luafiles directory.")
end
COM_AddCommand("fr_colorhelp", fr_colorhelp, 0)

addHook("IntermissionThinker", do
	N_WriteRandomToCVars()
	//if G_BattleGametype() return end -- nah
	if fr.restorecolors and fr.doteamstuff then
		fr.restorecolors = false
		for p in players.iterate do
			p.skincolor = p.FRoldskincolor
		end
	end

	if fr.scoreannounce == true then return end
	fr.scoreannounce = true
	if not fr_scorereport.value then return end
	local roundnum = "???"
	if server.roundnumber then roundnum = server.roundnumber end
	print("===== SCORE REPORT: ROUND #"..roundnum.." =====")
	print("\133"..string.upper(mapheaderinfo[gamemap].lvlttl).." "..string.upper(mapheaderinfo[gamemap].zonttl))
	print("TEAM "..blueprefix()..fr.bluename.."\128 VS TEAM "..orangeprefix()..fr.orangename)
	print("\131##\128| \131NAME                  \128| \131PTS")
	local sortedplayers = {}
	//print("storing players")
	for p in players.iterate do
		if p and p.valid and p.FRready and p.personalscore ~= nil then
			//print(p.name.." "..p.marescore)
			table.insert(sortedplayers, p)
		end
	end
	//print("table sorting")
	table.sort(sortedplayers,function(a, b)
		return a.personalscore > b.personalscore
	end)
	local i = 0
	local bluetotalthisround = 0
	local orangetotalthisround = 0
	//print("printing list")
	for _, q in ipairs(sortedplayers)
		i=$+1
		local pos = "??"
		local pname = "WHO THE FUCK??"
		local pscore = "##??" // I dont care if this actually ever shows up but it will be funny if it does
		if q.FRteam == 1 then
			pos = string.format("%02i",i)
			pname = blueprefix()..string.format("%-21s",q.name)
			pscore = blueprefix()..string.format("%4s",q.personalscore)
			bluetotalthisround = $+q.personalscore
		else
			pos = string.format("%02i",i)
			pname = orangeprefix()..string.format("%-21s",q.name)
			pscore = orangeprefix()..string.format("%4s",q.personalscore)
			orangetotalthisround = $+q.personalscore
		end
		print("\130"..pos.."\128| "..pname.." |\132"..pscore)
	end
	print(string.rep("-",31))
	print("THIS ROUND: "..blueprefix()..bluetotalthisround.."\128 - "..orangeprefix()..orangetotalthisround)
	server.bluetotalscore = $+bluetotalthisround
	server.orangetotalscore = $+orangetotalthisround
	print("GRAND TOTAL: "..blueprefix()..server.bluetotalscore.."\128 - "..orangeprefix()..server.orangetotalscore)
	server.roundnumber = $+1
end)

addHook("MapChange", do
	N_WriteRandomToCVars()
end)

addHook("MapLoad", do
	FRlog(server, "============ MapLoad hook START!")
	if not server.roundnumber then server.roundnumber = 1 end
	if not server.bluetotalscore then server.bluetotalscore = 0 end
	if not server.orangetotalscore then server.orangetotalscore = 0 end
	N_ReadRandomFromCVars()
	fr.scoreannounce = false
	fr.helpfuladvice = N_RandomRange(1, #FRtips)
	fr.ffasnark = N_RandomRange(1, #FRffa)
	fr.finalrecalc = false
	fr.bossrestock = false
	fr.bossgotemname = nil
	fr.bossgotemtimer = 0
	fr.bossprotect = false
	fr.savedtheworld = nil
	fr.restorecolors = true

	if CV_FindVar("elimination") and Elimination() then fr.elimon = true else fr.elimon = false end
	fr.slipdistance = fr_teamslipdistance.value
	fr.slipgrace = fr_teamslipgrace.value
	for p in players.iterate do
		--[[ FUCK THIS GAY EARTH, COMPLICATED COLOR RESTORE CODE FROM BEFORE INTERMISSIONTHINKERS
		p.FRteam = false
		p.FRsliptarget = nil
		if p.skincolor == realblue() or p.skincolor == realorange() then
			if p.FRoldskincolor then
				FRlog(p, "setting to old skin color: "..p.FRoldskincolor)
				p.skincolor = p.FRoldskincolor
				if p.mo then
					FRlog(p, "setting mo too")
					p.mo.color = p.skincolor
				end
			end
		else
			-- i feel like there should be logic here but there isn't
		end
		FRlog(p, "skincolor is "..p.skincolor)
		--]]
		p.FRoldskincolor = p.skincolor
		p.FRready = nil
		FRinit(p)
	end
	fr.doteamstuff = false
	if (countactive() > 1 or fr_debug.value) then
		fr.doteamstuff = fr_enabled.value
	end
	if fr.doteamstuff then
		if (countactive() < fr_minplayers.value) then
			FRlog(server, "teams force disabled, not enough players")
			fr.doteamstuff = false
			fr.bossmode = false
		elseif (N_RandomRange(1,100) > fr_teamchance.value) then
			FRlog(server, "teams force disabled, failed random chance")
			fr.doteamstuff = false
			fr.bossmode = false
		end
	end
	if not fr.doteamstuff then return end//no point in proceeding past here if we're FFA anyways
	fr.bossplayer = nil
	local teamnames = N_RandomRange(1, #FRteams)
	fr.bluename = "TEAM "..FRteams[teamnames].blue
	fr.orangename = "TEAM "..FRteams[teamnames].orange
	if not FRteams[teamnames].noflip and N_RandomRange(0, 1) then
		fr.bluename, fr.orangename = $2, $1
	end
	--fr.bluename = blueprefix()..fr.bluename.."\128"
	--fr.orangename = orangeprefix()..fr.orangename.."\128"
	local shuffledplayers = {}
	for p in players.iterate do
		table.insert(shuffledplayers, p)
	end
	FRlog(server, "Shuffling players")
	shuffledplayers = FYShuffle(shuffledplayers)
	if N_RandomRange(1, 100) <= fr_bosschance.value then
		FRlog(server, "boss mode")
		fr.bossmode = true
		fr.bluename = blueprefix()..fr_onesidename.string.."\128"
		for _, v in ipairs(shuffledplayers)
			if v.spectator then
				continue
			end
			local bosstargetname = sanitizebossname(v.name)
			if fr_forceboss.string != "Random" then
				FRlog(v, "Forceboss set, checking name against "..fr_forceboss.string)
				if string.find(string.lower(v.name), string.lower(fr_forceboss.string), 1, true) then
					FRlog(v, "mapload boss assignment: boss by name match")
					becometheboss(v)
					chatprintf(v,"<SERVER> You were force assigned as "..orangeprefix().."THE BOSS\128.")
				end
			elseif fr_bosschance.value == 100 and bosstargetname != fr.bossfocused then
				FRlog(v, "mapload boss assignment: server forcing fr.bossmode, pick anyone new")
				becometheboss(v)
				//chatprintf(v,"<SERVER> You were assigned as "..orangeprefix().."THE BOSS\128 since you did not win last match.")
			elseif fr_bosschance.value != 100 and bosstargetname == fr.bossfocused
				FRlog(v, "mapload boss assignment: server not forcing, picking last game's frontrunner")
				becometheboss(v)
				//chatprintf(v,"<SERVER> You were assigned as "..orangeprefix().."THE BOSS\128 since you won last match.")
			else
				FRlog(v, "mapload boss assignment: fell through, go home")
				assignteam(v, 1)
				chatprintf(v,"<SERVER> You were randomly assigned as "..orangeprefix().."THE BOSS\128.")
				v.FRlastboss = false
			end
		end
		if countorange() == 0 then
			FRlog(server, "mapload boss assignment: somehow we fucked up. pick somebody")
			for _, v in ipairs(shuffledplayers)
				if v.spectator then
					continue
				end
				becometheboss(v)
				break
			end
		end
	else
		FRlog(server, "no boss")
		fr.bossmode = false
		FRlog(server, "Assigning teams from shuffle")
		if fr_crewbattle.value then
			for _, v in ipairs(shuffledplayers)
				autoassignteam(v, true)
			end
		end
		for _, v in ipairs(shuffledplayers)
			autoassignteam(v)
		end
	end

	FRlog(server, "Doing overrides")
	if bluenameoverride() and not bluetag() then
		--fr.bluename = blueprefix().."TEAM "..fr.bluenameoverride.."\128"
		fr.bluename = fr_bluename.string
		if not orangenameoverride() then
			fr.orangename = fr_onesidename.string
		end
	end
	if orangenameoverride() and not orangetag() then
		--fr.orangename = orangeprefix().."TEAM "..fr.orangenameoverride.."\128"
		fr.orangename = fr_orangename.string
		if not bluenameoverride() then
			fr.bluename = fr_onesidename.string
		end
	end
	fr.blowout = false
	fr.fakepostracemusic = 0
end)

addHook("ThinkFrame", function()
	N_Random() -- advance for no reason to """seed"""
	//if G_BattleGametype() return end -- nah
	if fr_bosschance.value == 100 then
		for p in players.iterate
			if p == fr.bossplayer then
				fr.bossfocused = p.name
			end
		end
	else
		for p in players.iterate
			if p.kartstuff[k_position] == 1 then
				fr.bossfocused = p.name
			end
		end
	end
	if leveltime == 5 then
		if fr.bossmode and fr.doteamstuff then
			S_StartSound(nil, sfx_frboss)
		else
			S_StartSound(nil, sfx_fmssb0)
			if fr.doteamstuff then
				S_StartSound(nil, sfx_fmteam)
			else
				S_StartSound(nil, sfx_fmffa)
			end
		end
	end
	if (countactive() < 1 and not fr_debug.value) or (not fr.doteamstuff) then //countactive() < 2
		return
	end
	if fr.bossgotemtimer > 0 then
		fr.bossgotemtimer = $ - 1
	else
		fr.bossgotemname = nil
	end
	FRlog(server, "============== thinkframe start, leveltime "..leveltime)
	FRlog(server, "bluecolorlocal: "..fr_bluecolorlocal.value)
	FRlog(server, "orangecolorlocal: "..fr_orangecolorlocal.value)
	if fr.bossmode then
		FRlog(fr.bossplayer, "fr.bossmode ACTIVE!")
	end
	for p in players.iterate do
		if leveltime < 10 then
			continue
		end
		if not p.FRoldskincolor then
			p.FRoldskincolor = p.skincolor -- why do I have to do this
		end
	end
	for p in players.iterate do //reset this before we get to the main loop
		p.FRslipvisual = false
	end
	if G_BattleGametype() then //LMAO ALSO BATTLE RANKING HANDLING FUCK ASDGFHASJDGH
		local battlerankings = {}
		for p in players.iterate do
			if p and p.valid and not p.spectator then
				table.insert(battlerankings, p)
			end
		end
		table.sort(battlerankings, function(a, b)
			if a.kartstuff[k_bumper] == 0 and b.kartstuff[k_bumper] == 0 then return a.marescore > b.marescore end
			if a.marescore == b.marescore or
			(a.kartstuff[k_bumper] == 0 or b.kartstuff[k_bumper] == 0) then return a.kartstuff[k_bumper] > b.kartstuff[k_bumper] end
			return a.marescore > b.marescore
		end)
		for i=1, #battlerankings do
			//print(i.." "..#battlerankings)
			if i > 1 and battlerankings[i-1].marescore == battlerankings[i].marescore and
			battlerankings[i-1].kartstuff[k_bumper] == battlerankings[i].kartstuff[k_bumper] then
				battlerankings[i].kartstuff[k_position] = battlerankings[i-1].kartstuff[k_position]
			else
				battlerankings[i].kartstuff[k_position] = i
			end
		end
	end
	for p in players.iterate do
		if not p.FRconfigloaded then
			--COM_BufInsertText(p, "exec friendmod.cfg -noerror")
			p.FRconfigloaded = true
		end
		if p.spectator and not fr.elimon then
			FRlog(p, "stripping team from spectator")
			p.FRteam = false
		end
		if not fr.elimon and not p.mo then
			//print(p.name.." doesn't real")
			FRlog(p, "doesn't real")
			continue
		end
		if not p.valid then
			//print(p.name.." is invalied?????")
			FRlog(p, "invalid?")
			continue
		end
		FRlog(p, "running first iterator")
		local mo = nil //TODO: this looks bad (update 12-24-2020; I dont care, works)
		if p.mo then mo = p.mo end
		if not p.FRready then
			FRinit(p)
		end
		FRlog(p, "realskincolor: "..realskincolor(p))
		autoassignteam(p)
		if p.mo and not p.mo.colorized and (leveltime > 5) then
			mo.color = realskincolor(p)
			p.skincolor = realskincolor(p)
		end
		if p.FRreprisal > 0 then
			p.FRreprisal = $ - 1
		end
		if not fr.finalrecalc then
			p.personalscore = 0
			p.personalpassed = 0
			if fr.elimon then
				if not p.spectator then
					p.personalscore = 1
				else //in elim it just counts if you're alive or not
					p.personalscore = 0
				end
			elseif G_BattleGametype() then
				p.personalscore = p.marescore
			else
				for q in players.iterate do
					if p.FRteam != q.FRteam and p.kartstuff[k_position] < q.kartstuff[k_position] then
						p.personalpassed = $ + 1
						p.personalscore = $ + 2
					end
				end
				--local kicker = ")"
				if p.kartstuff[k_position] == 1 then
					p.personalscore = $ + 1
					--kicker = " + 1 for winning!)"
				end
			end
		end
		FRlog(p, "exiting: "..p.exiting)
		if p.FRteam then
			FRlog(p, "team: "..p.FRteam)
		else
			FRlog(p, "WTF, how did we get here without a team assignment")
		end

		if fr.bossmode and p.mo then -- the fr.bossmode block //if fr.bossmode then
			if fr.bossprotect and p == fr.bossplayer then
				fr.bossprotect = false
				if p.kartstuff[k_itemtype] == 0 and fr_bossprotectamount.value and (fr_bossprotectfront.value or fr.bossplayer.kartstuff[k_position] != 1) then
					p.kartstuff[k_itemtype] = fr_bossprotectitem.value
					p.kartstuff[k_itemamount] = fr_bossprotectamount.value
					bossflash()
					fr.bossrestock = false
				end
			end
			if p == fr.bossplayer then
				if leveltime == (5*TICRATE) and fr_bossstartamount.value > 0 then
					p.kartstuff[k_itemtype] = fr_bossstartitem.value
					p.kartstuff[k_itemamount] = fr_bossstartamount.value
					fr.bossrestock = false
					bossflash()
				end
				if fr.bossrestock and fr.bossplayer.kartstuff[k_position] != 1 and fr.bossplayer.FRlastframeitem == 0 then
					local okitems = {true, false, false, true, true, true, true, true, false, false, false, false, false, false, false, true} -- lol
					if p.kartstuff[k_itemtype] then
						if okitems[p.kartstuff[k_itemtype]] then
							if (p.kartstuff[k_itemamount] == 1 and fr_bossscalerestock.value) then
								p.kartstuff[k_itemamount] = $ + (fr_bossrestock.value / 2)
							else
								p.kartstuff[k_itemamount] = $ + fr_bossrestock.value
							end
							fr.bossrestock = false
						end
					end
				else
					if p.kartstuff[k_itemamount] == 0 then
						fr.bossrestock = true
					end
				end
			end
			if p.kartstuff[k_roulettetype] != 2 then
				if p == fr.bossplayer and fr_bosskarma.value then
					if p.kartstuff[k_position] != 1 then
						p.kartstuff[k_roulettetype] = 1
					else
						p.kartstuff[k_roulettetype] = 0
					end
				elseif fr_worldkarma.value
					if p.kartstuff[k_position] > fr.bossplayer.kartstuff[k_position] then
						p.kartstuff[k_roulettetype] = 1
					else
						p.kartstuff[k_roulettetype] = 0
					end
				end
			end
			if p != fr.bossplayer and p.FRlastframeitem == 0 and p.kartstuff[k_itemtype] > 0 then
				if not fr_worldpower.value and (p.kartstuff[k_position] <= fr.bossplayer.kartstuff[k_position] or fr_worldpoweralways.value) then
					if p.kartstuff[k_itemtype] == KITEM_GROW or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_ROCKETSNEAKER then
						p.kartstuff[k_itemtype] = fr_worldreplaceitem.value
						p.kartstuff[k_itemamount] = fr_worldreplaceamount.value
					end
				end
				if not fr_worldjawz.value and (p.kartstuff[k_position] <= fr.bossplayer.kartstuff[k_position] or fr_worldjawzalways.value) then
					if p.kartstuff[k_itemtype] == KITEM_JAWZ and p.kartstuff[k_itemamount] > 1 then
						p.kartstuff[k_itemamount] = 1
					end
				end
				if fr.bossplayer.kartstuff[k_position] != 1
					if p.kartstuff[k_itemtype] == KITEM_SPB then
						p.kartstuff[k_itemtype] = fr_bossspbgone.value
					end
				end
				if p.kartstuff[k_itemtype] == KITEM_SHRINK then
					p.kartstuff[k_itemtype] = fr_bossshrinkbgone.value
				end
			end
			p.FRlastframeitem = p.kartstuff[k_itemtype]
		end

		FRlog(p, "score: "..p.personalscore)
		FRlog(p, "oldskincolor: "..p.FRoldskincolor)
		FRlog(p, "finished: "..(finished(p) and "true" or "false"))
		FRlog(p, "timeover: "..((p.pflags & PF_TIMEOVER) and "true" or "false"))
		if p.playerstate == PST_LIVE and p.valid then
			if fr.bossmode then
				if p == fr.bossplayer then
					if G_BattleGametype() then
						p.kartstuff[k_wanted] = 9999999 //lol i dunno
					elseif not p.FRwanted then
						spawnwanted(p)
					elseif not p.FRwanted.valid then
						spawnwanted(p)
					end
					if p.FRwanted and p.FRwanted.valid then
						if (leveltime % 6) < 3 then
							p.FRwanted.colorized = true
							p.FRwanted.color = SKINCOLOR_CRIMSON
						else
							p.FRwanted.colorized = true
							p.FRwanted.color = SKINCOLOR_WHITE
						end
						if fr.localplayer == fr.bossplayer then
							p.FRwanted.flags2 = $|MF2_DONTDRAW
						else
							p.FRwanted.flags2 = $ & (~MF2_DONTDRAW)
						end
					end
				else
					if G_BattleGametype() then
						p.kartstuff[k_wanted] = 0
					end
				end
			end
			if p.mo then
				if not p.FRoverhead then
					FRlog(p,"no overhead, spawning")
					spawnoverhead(p)
				elseif not p.FRoverhead.valid then
					FRlog(p,"invalid overhead, spawning")
					spawnoverhead(p)
				end
				if p.FRoverhead.valid then
					FRlog(p,"doing overhead stuff")
					p.FRoverhead.state = S_PLAYERARROW_BOX
					p.FRoverhead.scale = FRACUNIT
					p.FRoverhead.angle = R_PointToAngle(p.FRoverhead.x, p.FRoverhead.y) + ANGLE_90;
					p.FRoverhead.color = realskincolor(p)
					if fr.localplayer != nil and fr.localplayer.valid and p.valid and p.FRoverhead.tracer and (not splitscreen) then
						if p.FRteam == fr.localplayer.FRteam and p != fr.localplayer and p.playerstate == PST_LIVE then
							p.FRoverhead.flags2 = $ & (~MF2_DONTDRAW)
							p.FRoverhead.tracer.flags2 = $ & (~MF2_DONTDRAW)
							FRlog(p,"draw overhead please")
						else
							p.FRoverhead.flags2 = $|MF2_DONTDRAW
							p.FRoverhead.tracer.flags2 = $|MF2_DONTDRAW
							FRlog(p,"don't draw overhead please")
						end
					end
					doframeshit(p)
					FRlog(p,"overhead color: "..p.FRoverhead.color)
				end //TEAM SLIPSTREAM CHARGE BUILD HERE
				if p.FRsliptarget and p.FRsliptarget.valid and p.FRsliptarget.mo and not p.kartstuff[k_spinouttimer] and not p.deadtimer and not p.spectator then
					local p1, p2 = p, p.FRsliptarget
					local dist = P_AproxDistance(P_AproxDistance(p1.mo.x - p2.mo.x, p1.mo.y - p2.mo.y),p1.mo.z - p2.mo.z)/FRACUNIT
					p1.FRtargetdistance = dist
					//p2.FRtargetdistance = dist
					//print("DISTANCE FOR "..p.name.." FROM "..p2.name.." IS "..dist)
					if dist <= fr.slipdistance and not p2.kartstuff[k_spinouttimer] and p1.kartstuff[k_position] > 1 and p2.kartstuff[k_position] > 1 then
						local mommul = 1
						p1.FRslipgrace = max(0, $-1)
						p2.FRslipgrace = max(0, $-1)
						p1.slipstreamcharge = min(240,$ + 1)
						p2.slipstreamcharge = min(240,$ + 1)
						if p1.FRslipvisual == false and leveltime%2 == 1 then //stops slip visuals from calculating more than once per player
							local p1travelang = R_PointToAngle2(0, 0, p1.mo.momx, p1.mo.momy)
							local p1angleconst = ANGLE_45
							if p1.kartstuff[k_aizdriftstrat] == 0 or not P_IsObjectOnGround(p1.mo) then p1angleconst = ANGLE_180 end
							local p1newx = p1.mo.x+P_ReturnThrustX(p1.mo,p1travelang-(p1.kartstuff[k_aizdriftstrat]*p1angleconst),FixedMul(24*FRACUNIT,p1.mo.scale))
							local p1newy = p1.mo.y+P_ReturnThrustY(p1.mo,p1travelang-(p1.kartstuff[k_aizdriftstrat]*p1angleconst),FixedMul(24*FRACUNIT,p1.mo.scale))
							local p1spark = P_SpawnMobj(p1newx,p1newy,p1.mo.z, MT_AIZDRIFTSTRAT)
							p1spark.angle = p1travelang+(p1.kartstuff[k_aizdriftstrat]*ANGLE_90)+ANG15
							p1spark.scale = p1.mo.scale/5
							p1spark.destscale = p1.mo.scale
							p1spark.color = p1.mo.color
							p1spark.colorized = true
							if p1.kartstuff[k_aizdriftstrat] == 0 or not P_IsObjectOnGround(p1.mo) then mommul = -2 end
							p1spark.momx = ((6*p1.mo.momx)/5)*mommul
							p1spark.momy = ((6*p1.mo.momy)/5)*mommul
							//p1spark.momz = ((6*p1.mo.momz)/5)*mommul
							K_MatchGenericExtraFlags(p1spark, p1.mo)
							p1.FRslipvisual = true
						end
						if p2.FRslipvisual == false and leveltime%2 == 1 then
							local p2travelang = R_PointToAngle2(0, 0, p2.mo.momx, p2.mo.momy)
							local p2angleconst = ANGLE_45
							if p2.kartstuff[k_aizdriftstrat] == 0 or not P_IsObjectOnGround(p2.mo) then p2angleconst = ANGLE_180 end
							local p2newx = p2.mo.x+P_ReturnThrustX(p2.mo,p2travelang-(p2.kartstuff[k_aizdriftstrat]*p2angleconst),FixedMul(24*FRACUNIT,p2.mo.scale))
							local p2newy = p2.mo.y+P_ReturnThrustY(p2.mo,p2travelang-(p2.kartstuff[k_aizdriftstrat]*p2angleconst),FixedMul(24*FRACUNIT,p2.mo.scale))
							local p2spark = P_SpawnMobj(p2newx,p2newy,p2.mo.z, MT_AIZDRIFTSTRAT)
							p2spark.angle = p2travelang+(p2.kartstuff[k_aizdriftstrat]*ANGLE_90)+ANG15
							p2spark.scale = p2.mo.scale/5
							p2spark.destscale = p2.mo.scale
							p2spark.color = p2.mo.color
							p2spark.colorized = true
							if p2.kartstuff[k_aizdriftstrat] == 0 or not P_IsObjectOnGround(p2.mo) then mommul = -2 else mommul = 1 end
							p2spark.momx = ((6*p2.mo.momx)/5)*mommul
							p2spark.momy = ((6*p2.mo.momy)/5)*mommul
							//p2spark.momz = ((6*p2.mo.momz)/5)*mommul
							K_MatchGenericExtraFlags(p2spark, p2.mo)
							p2.FRslipvisual = true
						end
					else
						if p.FRslipgrace < fr.slipgrace then
							p.FRslipgrace = $+1
						else
							p.FRsliptarget = nil
							p.FRslipgrace = 0
						end
					end
				else
					p.FRsliptarget = nil
					p.FRslipgrace = 0
				end
			end
		end
	end

	if not fr.finalrecalc then
		FRlog(server, "tallying scores")
		fr.bluescore = 0
		fr.orangescore = 0
		for p in players.iterate do
			if p.FRready and p.mo and not p.spectator then
				if p.FRteam == 1 then
					fr.bluescore = $ + p.personalscore
				else
					fr.orangescore = $ + p.personalscore
				end
			end
		end
	end

	local thinkbluefinished = bluefinished()
	local thinkorangefinished = orangefinished()
	local thinkbluenotfinished = bluenotfinished()
	local thinkorangenotfinished = orangenotfinished()
	if leveltime >= 3 and not G_BattleGametype() then
		if not fr.blowout and not fr.elimon then
			if thinkbluefinished and thinkorangenotfinished then
				FRlog(server, "blue fr.blowout")
				fr.blowout = true
				for p in players.iterate do
					FRlog(p, "blue fr.blowout check")
					if not supervalid(p) then
						continue
					end
					if p.FRteam == 2 and not (p.pflags & PF_TIMEOVER) then
						FRlog(p, "blue fr.blowout die")
						welcometofuckingdie(p)
					end
				end
			elseif thinkbluenotfinished and thinkorangefinished and (not fr.bossmode) then
				FRlog(server, "orange fr.blowout")
				fr.blowout = true
				for p in players.iterate do
					FRlog(p, "orange fr.blowout check")
					if not supervalid(p) then
						continue
					end
					if p.FRteam == 1 and not (p.pflags & PF_TIMEOVER) then
						FRlog(p, "orange fr.blowout die")
						welcometofuckingdie(p)
					end
				end
			elseif fr.bossmode and (countorange() == 0 or fr.bossplayer.pflags & PF_TIMEOVER) then
				FRlog(server, "fr.bossmode fr.blowout")
				--print("The boss spectated or otherwise disappeared.")
				for p in players.iterate do
					if not supervalid(p) then
						continue
					end
					if p.exiting then
						continue
					end
					p.exiting = 99
				end
				fr.blowout = true
			end
		end
	end

	if allfinished() or (G_BattleGametype() and (bluefinished() or orangefinished())) then
		FRlog(server, "finish")
		if not fr.finalrecalc then
			fr.bluescore = 0
			fr.orangescore = 0
			local numberwon = 0
			if fr.elimon then
				for p in players.iterate
					if not p.spectator then
						p.personalscore = 1
					else
						p.personalscore = 0
					end
					if p.FRteam == 1 then fr.bluescore = $ + p.personalscore end
					if p.FRteam == 2 then fr.orangescore = $ + p.personalscore end
				end
			elseif G_BattleGametype() then
				for p in players.iterate
					if not p.spectator then
						p.personalscore = p.marescore
					else
						p.personalscore = 0
					end
					if p.FRteam == 1 then fr.bluescore = $+p.personalscore end
					if p.FRteam == 2 then fr.orangescore = $+p.personalscore end
				end
			else
				for p in players.iterate
					if not supervalid(p) then continue end
					local temppersonal = p.personalscore
					p.personalscore = 0
					local finishedfirst = true
					for q in players.iterate
						if not supervalid(q) then continue end
						if p == q then continue end
						if p.realtime < q.realtime or (not (p.pflags & PF_TIMEOVER) and (q.pflags & PF_TIMEOVER)) then
							if p.FRteam != q.FRteam then
								p.personalscore = $ + 2
							end
							if fr.bossmode and p.FRteam == 1 and q.FRteam == 2 then
								numberwon = $ + 1
								fr.savedtheworld = p
							end
						else
							if p.realtime > q.realtime or (p.pflags & PF_TIMEOVER)-- ties for 1st
								finishedfirst = false
							end
						end
					end
					p.FRleader = finishedfirst
					if finishedfirst then
						p.personalscore = $ + 1
					end
					if temppersonal != p.personalscore then
						--print("Post-race scoring changed for "..p.name..": before was "..temppersonal..", after is "..p.personalscore)
					end
					if p.FRteam == 1 then
						fr.bluescore = $ + p.personalscore
					elseif p.FRteam == 2 then
						fr.orangescore = $ + p.personalscore
					end
				end
			end
			if numberwon != 1 then
				fr.savedtheworld = nil
			end
			--print("blue: "..fr.bluescore)
			--print("orange: "..fr.orangescore)
			fr.finalrecalc = true
			if abs(fr.bluescore - fr.orangescore) == 1 and not fr.bossmode then
				for p in players.iterate
					-- this is how you know i'm getting tired of writing this
					if p.FRleader == true and ((p.FRteam == 1 and fr.bluescore > fr.orangescore) or (p.FRteam == 2 and fr.orangescore > fr.bluescore)) then
						fr.savedtheworld = p
					end
				end
			end
		end
		FRlog(server, "allfinish music")
		fr.fakepostracemusic = $ + 1
		FRlog(server, "fr.fakepostracemusic: "..fr.fakepostracemusic)
		if fr.fakepostracemusic == 40 and fr.blowout then
			FRlog(server, "fr.blowout music")
			S_ChangeMusic("fatal", false)
		elseif fr.fakepostracemusic == 1
			S_StopMusic()
			if fr.blowout then
				FRlog(server, "fr.blowout sound")
				S_StartSoundAtVolume(nil, sfx_mugen, 255)
			elseif fr.bossmode and fr.bluescore == 0 then
				FRlog(server, "boss win sound")
				S_ChangeMusic("frover", false, p)
			elseif fr.savedtheworld then
				FRlog(server, "STW sound")
				S_ChangeMusic("fmstw", false, p)
			else
				FRlog(server, "not a fr.blowout")
				for p in players.iterate
					if teamwinning(p) or p.spectator then
						FRlog(p, "kbwin time")
						S_ChangeMusic("kbwin", false, p)
					elseif teamstied() then
						FRlog(p, "what does this even count as")
						S_StartSoundAtVolume(nil, sfx_fmdblk, 255)
					else
						FRlog(p, "kblose time")
						S_ChangeMusic("kblose", false, p)
					end
				end
			end
		end
		local manualexit = false
		FRlog(server, "starting allfinish iterator, time to do manualexit stuff")
		for p in players.iterate
			FRlog(p, "are you real")
			if not supervalid(p) then
				continue
			end
			FRlog(p, "doing allfinish iterator")
			if p.exiting == 99 and not p.FRstasis then
				FRlog(p, "Detonate handler")
				p.FRstasis = 5 * TICRATE - 2
			end
			if p.FRstasis == nil then
				if p.FRoneframedelay == nil then
					p.FRoneframedelay = true
					FRlog(p, "1f delay set")
				else
					FRlog(p, "stasis set")
					p.FRstasis = 10 * TICRATE
				end
			else
				p.FRstasis = $ - 1
				FRlog(p, "stasis ticking "..p.FRstasis)
				if p.FRstasis > 1 and not manualexit then
					p.exiting = 2
					FRlog(p, "exiting is "..p.exiting)
				else
					FRlog(p, "scoreboard set")
					manualexit = true
					FRlog(p, "DID WE SET MANUALEXIT YOU STUPID FUCK: "..(manualexit and "true" or "false"))
					if not G_BattleGametype() then
						p.pflags = $ & (~PF_TIMEOVER)
					end
					if teamwinning(p) then
						FRlog(p, "Last chance win setup")
						if not fr.elimon then p.realtime = 0 end
						//p.realtime = 0
						if not fr.blowout and not fr.elimon then
							FRlog(p, "win music change")
							S_ChangeMusic("krwin", true, p)
						end
					elseif teamstied() then
						FRlog(p, "Last chance tie?")
						if not fr.elimon then p.realtime = 0 end
						//p.realtime = 0
						if not fr.blowout and not fr.elimon then
							FRlog(p, "win music change")
							S_ChangeMusic("krwin", true, p)
						end
					else
						FRlog(p, "Last chance loss setup")
						if not fr.elimon and not G_BattleGametype() then
							p.realtime = 2
							p.pflags = $|PF_TIMEOVER
						end
						if not fr.blowout and not fr.elimon then
							FRlog(p, "loss music change")
							S_ChangeMusic("krlose", true, p)
						end
					end
				end
			end
		end
		if manualexit and not fr.elimon then //elim handles its own exit
			FRlog(server, "Manually exiting")
			COM_BufInsertText(server, "exitlevel")
		end
	end
	FRlog(server, "thinkframe most likely not on fire!")
end)

hud.add(function(v, p, c) -- AAAAAAAAAAHHHHHHHHHHHHH
	//if G_BattleGametype() return end -- nah
	fr.localplayer = p
	if (countactive() < 1 and not fr_debug.value) then //countactive() < 2
		return
	end
	if server.hmfinishstate then return end
	if not fr.doteamstuff
		if leveltime < (6 * TICRATE + (3 * TICRATE / 4)) then
			local ffaflag = 0
			if leveltime < (3 * TICRATE / 2) then
				ffaflag = (leveltime % 2) and V_70TRANS or 0
			end
			v.drawString(160, 2, "\133FREE FOR ALL", ffaflag, "center")
			v.drawString(160, 12, "GO FOR THE GOLD!", 0, "center")
			local overtaketutorial = FRffa[fr.ffasnark]
			local overtakeoffset = 160 - v.stringWidth(overtaketutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(overtakeoffset, 25, overtaketutorial, V_ALLOWLOWERCASE, "small")
		end
		return
	end
	if fr.doteamstuff and not p.spectator and not p.exiting then
		if p.FRsliptarget and not splitscreen then
			local slipflags = V_SNAPTORIGHT|V_SNAPTOBOTTOM
			if p.FRslipgrace > 0 and leveltime % 24 < 12 then slipflags = $|V_30TRANS end
			if p.FRtargetdistance > fr.slipdistance then
				slipflags = $|V_REDMAP
			elseif p.FRtargetdistance >= fr.slipdistance-(fr.slipdistance/4) then
				slipflags = $|V_ORANGEMAP
			else
				slipflags = $|V_YELLOWMAP
			end
			v.drawString(318,125,"TEAMSLIP!",slipflags, "right")
			v.drawString(318,135,"STAY CLOSE!",slipflags, "right")
			if p.FRslipgrace > 0 then
				local gracetime = string.format("%2i\34%02i",G_TicsToSeconds(fr.slipgrace-p.FRslipgrace),G_TicsToCentiseconds(fr.slipgrace-p.FRslipgrace))
				v.drawString(318,145,gracetime,slipflags,"right")
			end
		end
	end
	local bluenamehud = blueprefix()..fr.bluename.."\x80"
	local orangenamehud = orangeprefix()..fr.orangename.."\x80"
	if fr.elimon then //if you are reading this tyron I am so sorry
		if leveltime < 10 * TICRATE and not splitscreen and not p.spectator then
			if fr.bossmode then
				if p.FRteam == 2 then
					v.drawString(160, 2, "You are "..orangeprefix().."THE BOSS\128!", 0, "center") //160 2
					v.drawString(160, 12, "Defeat "..enemyname(p).."!", 0, "center") //160 12
				else
					v.drawString(160, 2, "Unite with "..bluenamehud.."!", 0, "center") //160 2
					v.drawString(160, 12, "Take down "..orangenamehud.."!", 0, "center") //160 12
				end
			else
				local bluetagtext = ""
				local orangetagtext = ""
				if fr_crewbattle.value then
					if fr_bluetag.string ~= nil and fr_bluetag.string ~= "" then bluetagtext = blueprefix().." ["..fr_bluetag.string.."]" end
					if fr_orangetag.string ~= nil and fr_bluetag.string ~= "" then orangetagtext = orangeprefix().." ["..fr_orangetag.string.."]" end
				end
				if p.FRteam == 1 then -- SHUT UP
					v.drawString(160, 2, "You are on "..bluenamehud.."."..bluetagtext, 0, "center") //160 12
					v.drawString(160, 12, "Defeat "..orangenamehud.."!"..orangetagtext, 0, "center") //160 12
				else
					v.drawString(160, 2, "You are on "..orangenamehud.."."..orangetagtext, 0, "center") //160 2
					v.drawString(160, 12, "Defeat "..bluenamehud.."!"..bluetagtext, 0, "center") //160 12
				end
			end
			local overtaketutorial = "OBJECTIVE: MAKE SURE YOUR TEAM SURVIVES"
			if fr.bossmode then
				overtaketutorial = orangeprefix().."BOSS WINS\128 if they survive. Defeat them at all costs."
				if p == fr.bossplayer then
					overtaketutorial = "OBJECTIVE: "..orangeprefix().."SURVIVE"
				end
			end
			local overtakeoffset = 160 - v.stringWidth(overtaketutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(overtakeoffset, 22, overtaketutorial, V_ALLOWLOWERCASE, "small") //overtakeoffset 25
			local teamattacktutorial = "Team Attack is ON: \133watch where you throw!"
			if not fr_teamattack.value then
				teamattacktutorial = "Team Attack is OFF: \131get up close and personal!"
			end
			local teamattackoffset = 160 - v.stringWidth(teamattacktutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(teamattackoffset, 27, teamattacktutorial, V_ALLOWLOWERCASE, "small") //teamattackoffset 30
			return
		end

		local blueflash = 0
		local orangeflash = 0
		if (leveltime % 10 >= 5 and not incomingblowout()) or (leveltime % 4 >= 2 and incomingblowout()) then
			if fr.bossmode then
				blueflash = (fr.bluescore == 0) and 0 or V_HUDTRANSHALF
				orangeflash = (fr.bluescore == 0) and V_HUDTRANSHALF or 0
			else
				if fr.bluescore > fr.orangescore
					blueflash = V_HUDTRANSHALF
				elseif fr.orangescore > fr.bluescore
					orangeflash = V_HUDTRANSHALF
				end
			end
		end
		if p.FRreprisal and (p.FRreprisal < 60 or not (leveltime % 2)) then
			v.drawString(160, 60, "TEAM DAMAGE!", V_REDMAP, "center") //160 60
		end
		if fr.bossmode and fr.bossplayer.valid then
			if fr.bossgotemtimer > 0 then
				if fr.bossgotemtimer < 87 or (leveltime % 2) then
					local bossgotemtext = blueprefix()..fr.bossgotemname.." \128NAILED THE BOSS!"
					if fr.bossgotemposition == 1 then
						bossgotemtext = blueprefix()..fr.bossgotemname.." \128LANDS A MIRACLE HIT!"
					end
					local bossgotemoffset = 160 - v.stringWidth(bossgotemtext, 0, "thin") / 2
					v.drawString(bossgotemoffset, 50, bossgotemtext, 0, "thin") //2
				end
			end //normally boss name doesn't draw if he's just been hit but its okay cause we got space for it on elim
			local hudbossname = orangeprefix()..orangenamehud
			//local hudbossoffset = 160 - v.stringWidth(hudbossname, orangeflash, "thin") / 2
			v.drawString(8, 175, hudbossname, V_SNAPTOLEFT|V_SNAPTOBOTTOM, "thin") //hudbossoffset, 2, thin
			if p == fr.bossplayer and not splitscreen and not fr.bossplayer.exiting then
				local bossremaining = fr.bossplayer.kartstuff[k_position] - 1
				if bossremaining > 0 or splitscreen then
					v.drawString(8, 185, orangeprefix().."PASS "..bossremaining.." TO WIN!", orangeflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM) //160 12
				else
					v.drawString(8, 185, orangeprefix().."STAY AHEAD!", orangeflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM) //160 12
				end
			else
				local posdisplay = fr.bossplayer.kartstuff[k_position]
				if #fr.prettyposition < posdisplay then //dude lmao battle royale or whatever --freeman
					posdisplay = string.rep(">",fr.bossplayer.kartstuff[k_position]-#fr.prettyposition)..">:[" //gets angrier the further behind 16th he is
				else
					posdisplay = fr.prettyposition[posdisplay]
				end
				v.drawString(8, 185, orangeprefix()..posdisplay.." PLACE", orangeflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM) //160 12
			end
		else
			local bluescoreoffset = v.stringWidth(blueprefix()..fr.bluescore, blueflash)
			local orangescoreoffset = v.stringWidth(orangeprefix()..fr.orangescore, orangeflash)
			v.drawString(10+bluescoreoffset, 175, bluenamehud, blueflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "thin") //155 2
			v.drawString(10+orangescoreoffset, 185, orangenamehud, orangeflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "thin") //165 2
			v.drawString(8, 175, blueprefix()..fr.bluescore, blueflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left") //155 12
			v.drawString(8, 185, orangeprefix()..fr.orangescore, orangeflash|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "left") //165 12
		end
	else//default HUD placement and code, before I made the adulteration above
		if leveltime < 10 * TICRATE and not splitscreen and not p.spectator then
			if fr.bossmode then
				if p.FRteam == 2 then
					v.drawString(160, 2, "You are "..orangeprefix().."THE BOSS\128!", 0, "center")
					v.drawString(160, 12, "Defeat "..enemyname(p).."!", 0, "center")
				else
					v.drawString(160, 2, "Unite with "..bluenamehud.."!", 0, "center")
					v.drawString(160, 12, "Take down "..orangenamehud.."!", 0, "center")
				end
			else
				local bluetagtext = ""
				local orangetagtext = ""
				if fr_crewbattle.value then
					if fr_bluetag.string ~= nil and fr_bluetag.string ~= "" then bluetagtext = blueprefix().." ["..fr_bluetag.string.."]" end
					if fr_orangetag.string ~= nil and fr_bluetag.string ~= "" then orangetagtext = orangeprefix().." ["..fr_orangetag.string.."]" end
				end
				if p.FRteam == 1 then -- SHUT UP
					v.drawString(160, 2, "You are on "..bluenamehud.."."..bluetagtext, 0, "center")
					v.drawString(160, 12, "Defeat "..orangenamehud.."!"..orangetagtext, 0, "center")
				else
					v.drawString(160, 2, "You are on "..orangenamehud.."."..orangetagtext, 0, "center")
					v.drawString(160, 12, "Defeat "..bluenamehud.."!"..bluetagtext, 0, "center")
				end
			end
			local overtaketutorial = "+2 per "..enemyprefix(p).."enemy\128 passed, +1 for first place"
			if fr.bossmode then
				overtaketutorial = orangeprefix().."BOSS WINS\128 if they finish 1st! Stop them at all costs!"
				if p == fr.bossplayer then
					overtaketutorial = "Your items are supercharged! "..orangeprefix().."Finish 1st\128 to win!"
				end
			end
			local overtakeoffset = 160 - v.stringWidth(overtaketutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(overtakeoffset, 25, overtaketutorial, V_ALLOWLOWERCASE, "small")
			local teamattacktutorial = "Team Attack is \133ON\128: watch where you throw!"
			if not fr_teamattack.value then
				teamattacktutorial = "Team Attack is \131OFF\128: get up close and personal!"
			end
			local teamattackoffset = 160 - v.stringWidth(teamattacktutorial, V_ALLOWLOWERCASE, "small") / 2
			v.drawString(teamattackoffset, 30, teamattacktutorial, V_ALLOWLOWERCASE, "small")
			return
		end
		local blueflash = 0
		local orangeflash = 0
		if (leveltime % 10 >= 5 and not incomingblowout()) or (leveltime % 4 >= 2 and incomingblowout()) then
			if fr.bossmode then
				blueflash = (fr.bluescore == 0) and 0 or V_HUDTRANSHALF
				orangeflash = (fr.bluescore == 0) and V_HUDTRANSHALF or 0
			else
				if fr.bluescore > fr.orangescore
					blueflash = V_HUDTRANSHALF
				elseif fr.orangescore > fr.bluescore
					orangeflash = V_HUDTRANSHALF
				end
			end
		end
		if p.FRreprisal and (p.FRreprisal < 60 or not (leveltime % 2)) then
			v.drawString(160, 60, "TEAM DAMAGE!", V_REDMAP, "center")
		end
		if fr.bossmode and fr.bossplayer.valid then
			if fr.bossgotemtimer > 0 then
				if fr.bossgotemtimer < 87 or (leveltime % 2) then
					local bossgotemtext = blueprefix()..fr.bossgotemname.." \128NAILED THE BOSS!"
					if fr.bossgotemposition == 1 then
						bossgotemtext = blueprefix()..fr.bossgotemname.." \128LANDS A MIRACLE HIT!"
					end
					local bossgotemoffset = 160 - v.stringWidth(bossgotemtext, 0, "thin") / 2
					v.drawString(bossgotemoffset, 2, bossgotemtext, 0, "thin")
				end
			else
				local hudbossname = orangeprefix()..orangenamehud
				local hudbossoffset = 160 - v.stringWidth(hudbossname, orangeflash, "thin") / 2
				v.drawString(hudbossoffset, 2, hudbossname, 0, "thin")
			end
			if p == fr.bossplayer and not splitscreen and not fr.bossplayer.exiting then
				local bossremaining = fr.bossplayer.kartstuff[k_position] - 1
				if bossremaining > 0 or splitscreen then
					v.drawString(160, 12, orangeprefix().."PASS "..bossremaining.." TO WIN!", orangeflash, "center")
				else
					v.drawString(160, 12, orangeprefix().."STAY AHEAD!", orangeflash, "center")
				end
			else
				v.drawString(160, 12, orangeprefix()..fr.prettyposition[fr.bossplayer.kartstuff[k_position]].." PLACE", orangeflash, "center")
			end
		else
			if p.FRteam == 1 or splitscreen or p.spectator then
				v.drawString(155, 2, bluenamehud, blueflash, "thin-right")
				v.drawString(165, 2, orangenamehud, orangeflash, "thin")
				if supervalid(p) and not splitscreen then
					v.drawString(155, 12, blueprefix().."+"..p.personalscore.." "..fr.bluescore, V_50TRANS, "right")
				end
				v.drawString(155, 12, blueprefix()..fr.bluescore, blueflash, "right")
				v.drawString(165, 12, orangeprefix()..fr.orangescore, orangeflash, "left")
			else
				v.drawString(155, 2, orangenamehud, orangeflash, "thin-right")
				v.drawString(165, 2, bluenamehud, blueflash, "thin")
				if supervalid(p) and not splitscreen  then
					v.drawString(155, 12, orangeprefix().."+"..p.personalscore.." "..fr.orangescore, V_50TRANS, "right")
				end
				v.drawString(155, 12, orangeprefix()..fr.orangescore, orangeflash, "right")
				v.drawString(165, 12, blueprefix()..fr.bluescore, blueflash, "left")
			end
		end
	end

	local leftoffset = 0
	local rightoffset = 0

	if allfinished() then
		if not fr.bossmode then
			if fr.blowout then
				if leveltime%4 >= 2 then
					v.drawString(160, 30, winningprefix().."FATAL KO", 0, "center")
				end
			elseif fr.bluescore > fr.orangescore
				v.drawString(160, 30, bluenamehud.." WINS!", 0,"center")
			elseif fr.orangescore > fr.bluescore
				v.drawString(160, 30, orangenamehud.." WINS!", 0, "center")
			else
				v.drawString(160, 30, "WHAT", 0, "center")
			end
		else
			if fr.blowout then
				v.drawString(160, 30, winningprefix().."FATAL KO", 0, "center")
			elseif fr.savedtheworld then
				local lazyflash = (leveltime % 2) and blueprefix() or "\128"
				v.drawString(160, 30, blueprefix()..fr.savedtheworld.name..lazyflash.." SAVED "..fr_onesidename.string.."!", 0,"center")
			elseif fr.bluescore >= 1 then
				v.drawString(160, 30, bluenamehud.." WINS!", 0,"center")
			elseif fr.bluescore == 0 then
				v.drawString(160, 30, orangenamehud.." WINS!", 0, "center")
			else
				v.drawString(160, 30, "WHAT", 0, "center")
			end
		end
	end
	if fr.elimon then //obscene elim scoring placement and logic
		if not splitscreen then
			if finished(p) or allfinished() then
				if not allfinished() then
					local helpfuladvicetext = fr.consoleprefix.."TIP: \128 "..FRtips[fr.helpfuladvice].first
					local helpfuladviceoffset = 160 - v.stringWidth(helpfuladvicetext, V_ALLOWLOWERCASE, "small") / 2
					v.drawString(helpfuladviceoffset, 30, helpfuladvicetext, V_ALLOWLOWERCASE, "small") //30
					local helpfuladvicetexttwo = FRtips[fr.helpfuladvice].second
					local helpfuladviceoffsettwo = 160 - v.stringWidth(helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small") / 2
					v.drawString(helpfuladviceoffsettwo, 35, helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small") //35
				end
				if not fr.bossmode then
					local sortedplayers = {}
					for q in players.iterate
						//TODO: UNFUCK
						//if q.mo and not q.spectator and q.FRready then
						if q.FRready and q.FRteam then
							table.insert(sortedplayers, q)
						end
					end
					table.sort(sortedplayers, function(a, b)
						if not fr.elimon then
							if not (finished(a) == finished(b)) then
								return finished(a)
							end
						end
						return a.personalscore > b.personalscore
					end)
					for _, q in ipairs(sortedplayers)
						local finishflag = V_ALLOWLOWERCASE
						if (fr.elimon) then
							if q.spectator then
								if consoleplayer == q and leveltime % 70 >= 35 then
									finishflag = $|V_YELLOWMAP|V_20TRANS
								else
									finishflag = $|V_GRAYMAP|V_20TRANS
								end
							end
						elseif not finished(q) then
							if consoleplayer == q and leveltime % 70 >= 35 then
								finishflag = $|V_YELLOWMAP|V_20TRANS
							else
								finishflag = $|V_GRAYMAP|V_20TRANS
							end
						elseif consoleplayer == q and leveltime % 70 >= 35 then
							finishflag = $|V_YELLOWMAP
						end
						local tempname = q.name
						if q == fr.savedtheworld then
							finishflag = (leveltime % 2) and finishflag or V_ALLOWLOWERCASE|V_YELLOWMAP
							if leveltime % 50 >= 25 then
								tempname = "CLUTCH!"
							end
						end
						//TODO: FUCKUN
						//if (not splitscreen and q.FRteam == p.FRteam) or (splitscreen and q.FRteam == 1) or (p.spectator and q.FRteam == 1) then
						if not splitscreen then
							if q.FRteam == 1
								v.drawString(155, 45 + leftoffset, teamprefix(q)..tempname.." - "..q.personalscore, finishflag, "thin-right")
								leftoffset = $ + 10
							else
								v.drawString(165, 45 + rightoffset, teamprefix(q)..q.personalscore.." - "..tempname, finishflag, "thin")
								rightoffset = $ + 10
							end
						end
					end
				end
			elseif not p.spectator and p.exiting != 1 and false -- shhh. no tears.
			//I half suspect this was never supposed to work
				local sortedplayers = {}
				for q in players.iterate
					//TODO: MCFUCK
					//if q.mo and not q.spectator and q.FRready and not (q.pflags & PF_TIMEOVER) and q.realtime <= fr.bossplayer.realtime and q.FRteam == 1 then
					if fr.elimon then
						if q.FRready and not(q.pflags & PF_TIMEOVER) and q.FRteam == 1 then
							table.insert(sortedplayers, q)
						end
					elseif q.mo and not q.spectator and q.FRready and not (q.pflags & PF_TIMEOVER) and q.realtime <= fr.bossplayer.realtime and q.FRteam == 1 then
						table.insert(sortedplayers, q)
					end
				end
				table.sort(sortedplayers, function(a, b)
					return a.realtime < b.realtime
				end)
				for _, q in ipairs(sortedplayers)
					local finishflag = V_ALLOWLOWERCASE
					if (fr.elimon) then
						if q.spectator then
							if consoleplayer == q and leveltime % 70 >= 35 then
								finishflag = $|V_YELLOWMAP|V_50TRANS
							else
								finishflag = $|V_GRAYMAP|V_50TRANS
							end
						end
					elseif not finished(q) then
						if consoleplayer == q and leveltime % 70 >= 35 then
							finishflag = $|V_YELLOWMAP|V_50TRANS
						else
							finishflag = $|V_GRAYMAP|V_50TRANS
						end
					elseif consoleplayer == q and leveltime % 70 >= 35 then
						finishflag = $|V_YELLOWMAP
					end
					v.drawString(155, 45 + leftoffset, teamprefix(q)..q.name, finishflag, "thin-right")
					//v.drawString(165, 45 + leftoffset, teamprefix(q)..fr.prettyposition[q.kartstuff[k_position]], finishflag, "thin")
					v.drawString(165, 45 + leftoffset, teamprefix(q)..q.personalscore, finishflag, "thin")
					leftoffset = $ + 10
				end
			end
		end
	else //default scoring location and logic
		if ((finished(p) and not G_BattleGametype()) and not splitscreen) or (allfinished() and splitscreen) then
			if not allfinished() and (G_BattleGametype() and p.kartstuff[k_comebacktimer] <= 5*TICRATE) then
				local helpfuladvicetext = fr.consoleprefix.."TIP: \128 "..FRtips[fr.helpfuladvice].first
				local helpfuladviceoffset = 160 - v.stringWidth(helpfuladvicetext, V_ALLOWLOWERCASE, "small") / 2
				v.drawString(helpfuladviceoffset, 30, helpfuladvicetext, V_ALLOWLOWERCASE, "small")
				local helpfuladvicetexttwo = FRtips[fr.helpfuladvice].second
				local helpfuladviceoffsettwo = 160 - v.stringWidth(helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small") / 2
				v.drawString(helpfuladviceoffsettwo, 35, helpfuladvicetexttwo, V_ALLOWLOWERCASE, "small")
			end
			if not fr.bossmode then
				local sortedplayers = {}
				for q in players.iterate
					if q.mo and not q.spectator and q.FRready then
						table.insert(sortedplayers, q)
					end
				end
				table.sort(sortedplayers, function(a, b)
					if G_BattleGametype() then return a.personalscore > b.personalscore end
					if not (finished(a) == finished(b)) then
						return finished(a)
					end
					return a.personalscore > b.personalscore
				end)
				for _, q in ipairs(sortedplayers)
					local finishflag = V_ALLOWLOWERCASE
					if not finished(q) then
						if consoleplayer == q and leveltime % 70 >= 35 then
							finishflag = $|V_YELLOWMAP|V_50TRANS
						else
							finishflag = $|V_GRAYMAP|V_50TRANS
						end
					elseif consoleplayer == q and leveltime % 70 >= 35 then
						finishflag = $|V_YELLOWMAP
					end
					local tempname = q.name
					if q == fr.savedtheworld then
						finishflag = (leveltime % 2) and finishflag or V_ALLOWLOWERCASE|V_YELLOWMAP
						if leveltime % 50 >= 25 then
							tempname = "CLUTCH!"
						end
					end
					if (not splitscreen and q.FRteam == p.FRteam) or (splitscreen and q.FRteam == 1) or (p.spectator and q.FRteam == 1) then
						v.drawString(155, 45 + leftoffset, teamprefix(q)..tempname.." - "..q.personalscore, finishflag, "thin-right")
						leftoffset = $ + 10
					else
						v.drawString(165, 45 + rightoffset, teamprefix(q)..q.personalscore.." - "..tempname, finishflag, "thin")
						rightoffset = $ + 10
					end
				end
			elseif not p.spectator and p.FRexiting != 1 -- shhh. no tears.
				local sortedplayers = {}
				if G_BattleGametype() then
					for q in players.iterate
						if q.mo and not q.spectator and q.FRready and not (q.pflags & PF_TIMEOVER) and q.marescore >= fr.bossplayer.marescore and q.FRteam == 1 then
							table.insert(sortedplayers, q)
						end
					end
				else
					for q in players.iterate
						if q.mo and not q.spectator and q.FRready and not (q.pflags & PF_TIMEOVER) and q.realtime <= fr.bossplayer.realtime and q.FRteam == 1 then
							table.insert(sortedplayers, q)
						end
					end
				end
				if G_BattleGametype() then
					table.sort(sortedplayers, function(a, b)
						return a.marescore < b.marescore
					end)
				else
					table.sort(sortedplayers, function(a, b)
						return a.realtime < b.realtime
					end)
				end
				for _, q in ipairs(sortedplayers)
					local finishflag = V_ALLOWLOWERCASE
					if not finished(q) then
						if consoleplayer == q and leveltime % 70 >= 35 then
							finishflag = $|V_YELLOWMAP|V_50TRANS
						else
							finishflag = $|V_GRAYMAP|V_50TRANS
						end
					elseif consoleplayer == q and leveltime % 70 >= 35 then
						finishflag = $|V_YELLOWMAP
					end
					v.drawString(155, 45 + leftoffset, teamprefix(q)..q.name, finishflag, "thin-right")
					if G_BattleGametype() then
						v.drawString(165, 45 + leftoffset, teamprefix(q)..q.marescore, finishflag, "thin")
					else
						v.drawString(165, 45 + leftoffset, teamprefix(q)..fr.prettyposition[q.kartstuff[k_position]], finishflag, "thin")
					end
					leftoffset = $ + 10
				end
			end
		end
	end
end)


local function maybeDoInstashield(p)
	if not fr_teamattack.value then
		K_DoInstashield(p)
	end
end

local function teamattackmirror(p)
	if (fr_teamattack.value or fr_teamreflect.value) and fr_teamwarning.value and not p.exiting then
		if p.FRreprisal < (2 * TICRATE - 10) then
			S_StartSoundAtVolume(nil, sfx_s3k50, 255, p)
			if fr_teamlog.value then
				COM_BufInsertText(server, "echo "..p.name.." attacked a teammate!")
			end
		end
		p.FRreprisal = 2 * TICRATE
	end
	if fr_teamreflect.value then
		S_StartSound(p.mo, sfx_kc3b)
		K_SpawnMineExplosion(p.mo, p.skincolor)
		P_DamageMobj(p.mo, nil, nil, 10000)
		K_DoInstashield(p)
	end
end

local function bossgotem(p)
	if fr.bossgotemtimer < 95 and p != fr.bossplayer and not fr.bossplayer.exiting then
		fr.bossgotemname = p.name
		fr.bossgotemtimer = TICRATE * 3
		fr.bossgotemposition = fr.bossplayer.kartstuff[k_position]
		if fr.bossgotemposition == 1 then
			S_StartSound(nil, sfx_fmpnch)
		else
			S_StartSound(nil, sfx_fmbshc)
		end
		fr.bossprotect = true
	end
end

-- muchos nachos to Snu for battle+ because i'm WAY too dumb to comb through source for this shit
-- a lot of nullguards and valid checks are taken from b+ because i assume they have a purpose and i'm very scared
addHook("ShouldSpin", function(p, inflictor, source)
	if not fr.doteamstuff then
		return
	end
	if (source and source.player and (p ~= source.player))
	and not (not source.player.kartstuff[k_invincibilitytimer] and (inflictor and inflictor.player and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring])))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif fr.bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

addHook("ShouldSquish", function(p, inflictor, source)
	if not fr.doteamstuff then
		return
	end
	if (source and source.player and (p ~= source.player))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif p.kartstuff[k_squishedtimer] > 0 then
			return false //without this, this was causing players squished by their own team to be squished every tic
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif fr.bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

addHook("ShouldExplode", function(p, inflictor, source)
	if not fr.doteamstuff then
		return
	end
	if (source and source.player and (p ~= source.player))
		if p.kartstuff[k_invincibilitytimer] or (p.kartstuff[k_growshrinktimer] > 0) then
			K_DoInstashield(p)
			return false
		elseif (p.FRteam == source.player.FRteam) then
			teamattackmirror(source.player)
			maybeDoInstashield(p)
			return fr_teamattack.value
		elseif fr.bossmode then
			bossgotem(source.player)
		end
	end
	return
end)

local flashItems = {MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_BANANA, MT_BANANA_SHIELD, MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_DUD, MT_JAWZ_SHIELD, MT_SSMINE_SHIELD, MT_SSMINE, MT_BALLHOG, MT_SPB, MT_SINK}
for i = 1, #flashItems
	addHook("MobjThinker", function(mo)
		if not fr.doteamstuff then
			return
		end
		if not fr_teamattack.value then
			if (mo and mo.valid)
				if mo.target and (fr.localplayer and fr.localplayer.valid)
					if (mo.target.player.FRteam == fr.localplayer.FRteam) and (mo.target.player != fr.localplayer) then
						//mo.flags2 = $ | MF2_SHADOW
						mo.colorized = true
						mo.color = realskincolor(mo.target.player)
					end
				end
			end
		end
	end, flashItems[i])
end

local function FRIENDMOD_Bump(mobj1, mobj2)
	if not ((mobj1.z >= mobj2.z and mobj1.z < mobj2.z + mobj2.height) or (mobj2.z >= mobj1.z and mobj2.z < mobj1.z + mobj1.height)) then
		return
    end //cannot fucking BELIVE this has to be checked manually
	//print("BONK CHECK START")
	local ss_on = false
	if CV_FindVar("slipstream_enabled") then ss_on = CV_FindVar("slipstream_enabled").value end
	//print("SLIPSTREAM A OKAY")
	if not ss_on then return end //no slipstream to transfer lmao
	if not fr_teamslipstream.value then return end
	//print("TEAMSLIP CONFIG OKAY")
	if mobj1.valid and mobj1.player and mobj2 and mobj2.valid and mobj2.player then
		//print("BOTH IDIOTS ARE VALID PLAYERS")
		local p1, p2 = mobj1.player, mobj2.player
		if fr.doteamstuff and p1.FRteam == p2.FRteam then
			//print("TEAMS ARE ON AND THEY'RE TEAMMATES")
			local cv_chargetoboost = CV_FindVar("slipstream_chargetoboost").value - 70 //gives some leeway
			//print("CHARGE TO BOOST IS "..cv_chargetoboost)
			if p1.mo.slipstreamcharge and p1.mo.slipstreamboost and p1.mo.slipstreamcharge >= cv_chargetoboost then
				//print("P1: "..p1.name.." TRANSFERED GOODS TO P2: "..p2.name)
				p2.mo.slipstreamcharge = max($, 1)
				p2.mo.slipstreamboost = max($, 1)
				S_StartSound(p2.mo, sfx_zoom)
				//S_StartSound(p2.mo, sfx_zoom, p2)
				if p1.FRsliptarget == nil then S_StartSound(nil, sfx_ncitem, p1) end
				if p2.FRsliptarget == nil then S_StartSound(nil, sfx_ncitem, p2) end
				p1.FRsliptarget = p2
				p2.FRsliptarget = p1
			elseif p2.mo.slipstreamcharge and p2.mo.slipstreamboost and p2.mo.slipstreamcharge >= cv_chargetoboost then
				p1.mo.slipstreamcharge = max($, 1) //TODO: ??????
				p1.mo.slipstreamboost = max($, 1)
				//print("P2: "..p2.name.." TRANSFERED GOODS TO P1: "..p1.name)
				S_StartSound(p1.mo, sfx_zoom)
				//S_StartSound(p2.mo, sfx_zoom, p2)
				if p1.FRsliptarget == nil then S_StartSound(nil, sfx_ncitem, p1) end
				if p2.FRsliptarget == nil then S_StartSound(nil, sfx_ncitem, p2) end
				p1.FRsliptarget = p2
				p2.FRsliptarget = p1
			end
		//print("FUCKED OFF: NOT TEAMS")
		end
	end
end

addHook("MobjCollide", FRIENDMOD_Bump, MT_PLAYER)

rawset(_G, "FRIENDMOD_ToggleTeams", function(...)
	fr_enabled.value = not fr_enabled.value
	return fr_enabled.value
end)

rawset(_G, "FRIENDMOD_CheckTeams", function(...)
	return fr_enabled.value
end)

rawset(_G, "FRIENDMOD_TeamBattle", function(...)
	return fr.doteamstuff
end)